Attribute VB_Name = "web_auxiliary"
Option Explicit

'Original refers to StartUp set
'  in original, unconverted, application.
'  Original startup is set
'     for VB4 in SDK/menu/Tools/Options/Project/
'             StartUp Form
'             via Sub Main or one of the forms
'     for VB6 in SDK from Projects window
'             via Project Properties/General/
'                 Start Up Object

Public web_OriginalStartUpDone$


Public web_TimersCompleted$
'for debug:
Public web_c As web_frmConsole
Public web_SID$  'session id
Public web_EnteredDestrNoTimers$ 'blocker


Public web_ZO&()
Public web_OZ&()
Public web_ZOChangedAtServer As Boolean
  
Public web_LoadedForms$
Public web_LoadedFormsArray() As Form

Public web_InformTerminationToClient As Boolean   '0/-1  for False/True

'Public web_IAmBack As Boolean
'Public web_YouCanGo As Boolean
'redundant if timer does not allow recursion:
'Public web_TimerIsBusy As Boolean
'temporarily 10 seconds:
'Public web_ResponseTo&
'Public web_ServerDidNotComplete As Boolean
'Public web_ReleaseWebClassToGo As Boolean
'Public web_TimerIsSpinning As Boolean
Public web_FormsUnloading$


'Public web_ExceptionMessage$
'Public web_Msg$

'provided as flag to be used by programmer
'for further code modifications:
Public web_AllowLocal$  '"W" or "L"
Public web_StatusBarMessage$


Public Declare Function GetTickCount Lib "kernel32" () As Long

'DESC Bookkeeping for form placed/removed
'     on/from top of Z-Order.
'
'INPU lngVal = 0              removed;
'              overwise placed on top;
'
'NOTE
'  web_ZO - ZOrder as function of form
'      OZ - inverse function
'           variable Ubound; = maxZO
'
Public Sub web_ZOManage(frmIndex&, lngVal&)

Dim web_ZOMax&
Dim wZO&, I&, j&
  
web_d "Entered web_ZOManage: z-top=" & lngVal

'=================================
'automatically adjust ZO holder:
'if form is not in this array:
'---------------------------------
I = UBound(web_ZO)
If I < frmIndex Then
   ReDim Preserve web_ZO(frmIndex)
   For j = I + 1 To frmIndex
      'all not mentioned forms are
      'obviously non-loaded:
      web_ZO(j) = -1
   Next
End If
'=================================

Select Case lngVal
Case 0, -1 'Mark form as invisible/unloaded.

  'form is not in bookkeeper:
  If UBound(web_ZO) < frmIndex Then Exit Sub
  
  web_ZOMax = UBound(web_OZ)
  
  wZO = web_ZO(frmIndex)
  If wZO > 0 Then
     For I = wZO To web_ZOMax - 1
         web_OZ(I) = web_OZ(I + 1)
         web_ZO(web_OZ(I)) = I
     Next
     'set right status:
     web_ZO(frmIndex) = lngVal
     'remove from z-indexes:
     ReDim Preserve web_OZ(web_ZOMax - 1)
     web_ZOChangedAtServer = True
     web_d CStr(frmIndex) & _
         " removed/unloaded from z-top."
  End If

  
Case Else 'true: add to the z-top:
  
  web_ZOMax = UBound(web_OZ)
  wZO = web_ZO(frmIndex)
  
  If wZO < 1 Then
     'form is not in z-index;
     'update direct array:
     web_ZOMax = web_ZOMax + 1
     web_ZO(frmIndex) = web_ZOMax
     'complactly expand form's array:
     ReDim Preserve web_OZ(web_ZOMax)
     web_OZ(web_ZOMax) = frmIndex
     
     'protocol changes:
     web_ZOChangedAtServer = True
     web_d CStr(frmIndex) & _
         " added to z-top=" & web_ZOMax
  ElseIf wZO < web_ZOMax Then
     'form is in z-index, but not on top;
     
     'bubble top part down:
     For I = wZO To web_ZOMax - 1
         web_OZ(I) = web_OZ(I + 1)
         web_ZO(web_OZ(I)) = I
     Next
     'put form on top:
     web_OZ(web_ZOMax) = frmIndex
     
     'protocol changes:
     web_ZOChangedAtServer = True
     web_d CStr(frmIndex) & _
         " moved to z-top=" & web_ZOMax
  End If
End Select

web_d "Exited web_ZOManage"

End Sub

Public Sub web_d(s$)
  If Not web_c Is Nothing Then web_c.t s
End Sub

'this is a redundant wrapper:
'but, it is already in use, so keep it:
Public Sub web_FormVis(ob As Form, v&)
   ob.web_mSetVis ob, v
End Sub

Public Function web_GetFormVis&(ob As Form)
  web_GetFormVis = ob.web_mGetVis(ob)
End Function

Public Sub web_SetVis(ob As Object, v&)
  'this is legal: TypeOf ob Is Form:
  'http://msdn.microsoft.com/library/default.asp?url=/library/en-us/vbcn7/html/vaconobjvarvalues.asp
  'Visual Basic Language Concepts
  'Object Variable Values
  If TypeOf ob Is Form Then
     ob.web_mSetVis ob, v
  Else
     ob.Parent.web_mSetVis ob, v
  End If
End Sub

Public Function web_GetVis&(ob As Object)
  web_GetVis = ob.Parent.web_mGetVis(ob)
End Function

'<<<*>>> To Replace "End" Statement
Public Sub web_End()

 Close
 
 'this is a flag for forms and
 'web_class:
 'this flag may be put
 'to all unload events in forms
 'to block any unload code:
 web_InformTerminationToClient = True

 Destroy_IfNoTimers
 
End Sub



'micro helper:
Public Sub mic_BuildLoadedForms()
   Dim frm As Form, I&
   web_LoadedForms = ""
   ReDim web_LoadedFormsArray(0)
   For Each frm In Forms
       web_LoadedForms = _
           web_LoadedForms & frm.Name & vbCrLf
       I = UBound(web_LoadedFormsArray) + 1
       ReDim Preserve web_LoadedFormsArray(I)
       Set web_LoadedFormsArray(I) = frm
   Next
   web_d "Loaded forms: " & vbCrLf & _
         web_LoadedForms
End Sub

'===========================================
'micro helper:
'destroys all forms:
'protects itself from recursion;
'can be called safely from
'as many times as wanted, with assumption
'that form-object, first
'unloads, then may be destroys;
'
Public Sub web_DestroyAllForms()
'-------------------------------------------
  Dim s1$, s2$
  'to avoid recursion:
  If "T" = web_FormsUnloading Then Exit Sub
  web_d "Unloading all forms ... "
  web_FormsUnloading = "T"
  mic_BuildLoadedForms
  web_d "Unloaded forms have been built."
  Do While UBound(web_LoadedFormsArray) > 0
    
     'Unload startup form only in "last order"
     'to prevent presumed original order of
     'unload:
     s1 = web_LoadedFormsArray(1).Name
     If UBound(web_LoadedFormsArray) > 1 And _
        UCase("frmMainForm") = _
        UCase(s1) Then
          s2 = web_LoadedFormsArray(2).Name
          web_d "Unloading " & s2
        Unload web_LoadedFormsArray(2)
        web_d "Done:" & s2
     Else
        web_d "Unloading " & s1
        Unload web_LoadedFormsArray(1)
        web_d "Done: " & s1
     End If
      
     'interference with
     'another destroyers eliminated:
     mic_BuildLoadedForms
  Loop
  web_d "All forms unloaded ... "

End Sub
'===========================================

Public Function Destroy_IfNoTimers()
  'If no timers, do this:
  web_DestroyAllForms
  'otherwise, add the code to handle shudtown
  'tasks via timers.
  'If timers are busy: return non-empty string.
  'Asp-code will take care to let timers finish.
  'If clear, returns empty string:
  Destroy_IfNoTimers = ""
End Function






'<<<*>>> ListBox helper
Public Function web_Display_ListBox$( _
                ob As Control)
  Dim I&, res$, ws$
  If ob.ListCount = 0 Then Exit Function
  With ob
    For I = 0 To .ListCount - 1
       ws = ""
       If I = .ListIndex Then ws = " selected "
       res = res & _
           "<option value=""" & I & """" & ws & " />" & _
             .List(I) & vbCrLf
    Next
  End With
  web_Display_ListBox = res
End Function


