Attribute VB_Name = "Replacer"
Option Explicit


'EXCEPTIONS   free
'YELDS        no
'
'DESCR        Replaces one character
'             if ANY of chars in Ke_ys
'             is encountered.
'NOTE         Slow
'DEPENDENCIES No
Public Function RePlaceBatch$( _
       S_IN$, Ke_ys$, Va_lue$)
Dim WI&, WS$, l&, result$

result = ""
l = Len(S_IN)
If l = 0 Then Exit Function
  
For WI = 1 To l
   WS = Mid(S_IN, WI, 1)
   If InStr(Ke_ys, WS) > 0 Then WS = Va_lue
   result = result & WS
Next

RePlaceBatch = result

End Function


'EXCEPTIONS:         free unconditionally.
'INPUT RESTRICTINS:  none.
'YELDS:              depends on Yeld input par.
'
'
Public Function RePlaceFast$( _
       s$, Ke_y$, Va_lue$, _
       Yeld As Boolean)
Dim i&, l&, Sta_rt&, WRePlaceFast$, Key_Length$

WRePlaceFast = s
l = Len(s)
If l = 0 Then GoTo ExitFunction
Key_Length = Len(Ke_y)
If Key_Length = 0 Then Exit Function

Sta_rt = 1
WRePlaceFast = ""
i = InStr(Sta_rt, s, Ke_y)
Do While i <> 0
   If Yeld Then DoEvents
   'add piece before escape char:
   WRePlaceFast = WRePlaceFast & _
         Mid(s, Sta_rt, i - Sta_rt)
   WRePlaceFast = WRePlaceFast & Va_lue
   Sta_rt = i + Key_Length
   i = InStr(Sta_rt, s, Ke_y)
Loop
If Sta_rt <= l Then WRePlaceFast = _
        WRePlaceFast & Mid(s, Sta_rt)
ExitFunction: RePlaceFast = WRePlaceFast
Exit Function

End Function


