VERSION 5.00
Begin VB.Form frmSelectCharsToEscape 
   Caption         =   "Tune up hexadecimal text view"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11175
   Icon            =   "frmSelectCharsToEscape.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3090
   ScaleWidth      =   11175
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   2280
      TabIndex        =   9
      Top             =   2520
      Width           =   4095
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Apply"
      Height          =   495
      Left            =   6480
      TabIndex        =   8
      Top             =   2520
      Width           =   4575
   End
   Begin VB.CommandButton cmdAddToEscapees 
      Caption         =   "add "
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   2040
      Width           =   1095
   End
   Begin VB.TextBox txtEscapeChar 
      Height          =   285
      Left            =   1800
      MaxLength       =   1
      TabIndex        =   4
      Top             =   2640
      Width           =   255
   End
   Begin VB.TextBox txtCharsToCopyAndPaste 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   765
      Left            =   1800
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   2
      Text            =   "frmSelectCharsToEscape.frx":030A
      Top             =   1680
      Width           =   9255
   End
   Begin VB.TextBox txtSelected 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1455
      Left            =   1800
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   9255
   End
   Begin VB.Label lbllblSelect2 
      Caption         =   "to upper text box."
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2280
      Width           =   1575
   End
   Begin VB.Label lbllblEscapeChar 
      BackColor       =   &H80000011&
      Caption         =   "Escape character:"
      ForeColor       =   &H8000000E&
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   2640
      Width           =   1455
   End
   Begin VB.Label lbllblCopyAndPaste 
      Caption         =   "Select characters from  the first row and"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   1680
      Width           =   1575
   End
   Begin VB.Label lbllblSelected 
      BackColor       =   &H8000000C&
      Caption         =   "This characters will  be escaped.  (Zero and single CR are always if in text .) Characters can be pasted here from text."
      ForeColor       =   &H8000000E&
      Height          =   1215
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   1575
   End
End
Attribute VB_Name = "frmSelectCharsToEscape"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private BlockChangeOfText As Boolean
Private CharRange$
Private Escape_Char$

Private Sub cmdAddToEscapees_Click()
Dim display_chars$
Dim L&, wi&, WII&
Dim WPosition&


With txtCharsToCopyAndPaste

If .SelLength = 0 Then Exit Sub
If .SelLength > 255 Then Exit Sub
If .SelStart >= 255 Then Exit Sub
If .SelStart + .SelLength > 255 Then Exit Sub 'kk rev 16.

WII = .SelStart
For wi = 1 To .SelLength
    If InStr(CharRange, Chr(wi + WII)) = 0 Then
       CharRange = CharRange & Chr(wi + WII)
    End If
Next
End With


If InStr(CharRange, vbCr) > 0 And InStr(CharRange, vbLf) = 0 Then
   CharRange = CharRange & vbLf
ElseIf InStr(CharRange, vbCr) = 0 And InStr(CharRange, vbLf) > 0 Then
   CharRange = CharRange & vbCr
End If


BlockChangeOfText = True
WPosition = Len(CharRange)
'"A" - may not the best ... :
If Len(Escape_Char) <> 1 Or Len(CharRange) = 0 Then
   txtSelected.Text = ""
Else
   txtSelected.Text = asc_T(CharRange, Escape_Char, CharRange, "A", WPosition)
End If
BlockChangeOfText = False

End Sub

Private Sub cmdCancel_Click()
Unload Me
End Sub

Private Sub cmdClose_Click()
Select Case gui_CurrentElement
       Case gui_SCHEMA
                        If txtEscapeChar.Text <> "" Then _
                        sc_t_Escape = txtEscapeChar.Text
                        sc_EscapeRow = CharRange
       Case gui_SOURCE
                        If txtEscapeChar.Text <> "" Then _
                        so_t_Escape = txtEscapeChar.Text
                        so_EscapeRow = CharRange
       Case gui_RESULT
                        If txtEscapeChar.Text <> "" Then _
                        re_t_Escape = txtEscapeChar.Text
                        re_EscapeRow = CharRange
End Select
Unload Me
End Sub

Private Sub Form_Load()
Dim display_chars$, WPosition&
CenterForm Me
Select Case gui_CurrentElement
       Case gui_SCHEMA: CharRange = sc_EscapeRow
                        txtEscapeChar.Text = sc_t_Escape
       Case gui_SOURCE: CharRange = so_EscapeRow
                        txtEscapeChar.Text = so_t_Escape
       Case gui_RESULT: CharRange = re_EscapeRow
                        txtEscapeChar.Text = re_t_Escape
End Select
End Sub




Private Sub txtEscapeChar_Change()
Dim display_chars$, WDummy&
Dim WPosition&

Escape_Char = txtEscapeChar.Text
If txtEscapeChar.Text = "" Then Escape_Char = "^" 'make it default hiddenly;

BlockChangeOfText = True
WPosition = Len(CharRange)
txtSelected.Text = asc_T(CharRange, Escape_Char, CharRange, "A", WPosition)
BlockChangeOfText = False

End Sub


Private Sub txtSelected_Change()
Dim display_chars$, WDummy&
Dim WPosition&

If BlockChangeOfText Then Exit Sub

display_chars = Replace(Replace(Replace(Replace(txtSelected.Text, " ", ""), vbTab, ""), vbCr, ""), vbLf, "")
'former CharRange is user to unescape chars ", and then" new chars added to CharRange:
CharRange = asc_UT(display_chars, Escape_Char, CharRange, WDummy)
'If InStr(CharRange, Chr(0)) = 0 Then CharRange = CharRange & Chr(0)
If InStr(CharRange, vbCr) > 0 And InStr(CharRange, vbLf) = 0 Then
   CharRange = CharRange & vbLf
ElseIf InStr(CharRange, vbCr) = 0 And InStr(CharRange, vbLf) > 0 Then
   CharRange = CharRange & vbCr
End If

BlockChangeOfText = True
WPosition = Len(CharRange)
txtSelected.Text = asc_T(CharRange, Escape_Char, CharRange, "A", WPosition)
BlockChangeOfText = False


End Sub


