VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CProcedure"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private deb As Boolean
Public pdeb As Boolean

Public indent_body$

Private moDlg As CDialog
Private moPr As CPrint
Private moDv As CDiskVariables
Private moVr As CVariables
Private moTz As CTokenizer
Private moAc As Acto
Private moFt As CFolderTree

'Switches:
Public env_output_case$
Public env_make_indent_at_each_state As Boolean

'For exception
Private espot$
Private xMe$, xNo&


'Variables which were global before:
Public p_stop_browsing_project_tree$



Public Sub SetMoActo(ac As Acto)
Set moAc = ac
End Sub

Public Sub SetMoFolderTree(ft As CFolderTree)
Set moFt = ft
End Sub

Public Sub SetMoVariables(vr As CVariables)
Set moVr = vr
End Sub

Public Sub SetMoTokenizer(tz As CTokenizer)
Set moTz = tz
End Sub

Public Sub SetMoPrint(pr As CPrint)
Set moPr = pr
End Sub

Public Sub SetMoDiskVariables(dv As CDiskVariables)
Set moDv = dv
End Sub

'
'"storage" for new-included-in-code-subroutines
'
Sub Procedure1_custom(ac$, P$)
  Select Case ac
    Case "hello": hello_custom (P)
    Case Else
         e_stop "Command `" & ac & "` does not exist ..."
  End Select
End Sub


Public Sub SetDebug(db As Boolean)
deb = db
End Sub

Private Sub hello_custom(s$)
    moPr.PrintL "hello " & s
End Sub

'EXCE Free
'DESC Creates mopr.Indent_Replacer according to
'     "-s" in global nest and indent_body.
'
'     or according env_make_indent_at_each_state
'
Sub MakeIndentReplacer()
    
Dim I&
moDlg.Indent_Replacer = ve
If moDlg.dlgPs < 1 Then Exit Sub
    
For I = 1 To moDlg.dlgPs
    If moDlg.RunTimeNest(I) = si__Statement Or _
       env_make_indent_at_each_state Then
       'this increases an indent
       moDlg.Indent_Replacer = moDlg.Indent_Replacer & indent_body
    End If
Next

End Sub


'NOTE Generalization CommandParam --> EscapedString
'     should be done.
'
Public Function proc_Command( _
       CommandToRun$, CommandParam$, ResultedTextType$) As Boolean
Dim wi&, ws$, wws$, variable$, file_name$
Dim WOpenOption$
Dim abs_name_prepared$
Dim Oper2PreValue$
Dim NewPos&

proc_Command = True

'put this "if" for speed:
If "PUT$" = UCase(Left(CommandToRun, 4)) Then
        '..put$disk-variable.CommandParam:
        GoSub PrepareOper2Value
        If 0 <> Len(Oper2PreValue) Then _
           moDv.PutVar Mid(CommandToRun, 5), Oper2PreValue
        Exit Function
End If


Select Case CommandToRun  '>>select -1 Select Case CommandToRun
     
    Case aCP__OUTPUT_CASE:  env_output_case$ = UCase(CommandParam)
    
    Case aCP__INDENT_BODY: indent_body = CommandParam
        If deb Then moPr.PrintL "INDENT CONSTANT=" & indent_body & "<END OF INDENT CONSTANT>"
   
    
    Case aCP_TOKENS_CASE_SENSETIVE:
         If Make_Boolean(CommandParam) Then
            moDlg.env_word_case_sensetive = True
            moTz.env_keyword_case_sensetive = True
            moTz.env_separator_case_sensetive = True
         Else
            moDlg.env_word_case_sensetive = False
            moTz.env_keyword_case_sensetive = False
            moTz.env_separator_case_sensetive = False
         End If
    
    
    Case aCP__BASIC_ENVIRONMENT: switchBasicEnvironment CommandParam
    'Case aCP__EVENT_STATEMENT_MASK: env_event_statement_mask = CommandParam
    
    Case aCP__TOKENIZER_RECONIZES_QUOTED_STRINGS
         moTz.env_recongnize_strings = Make_Boolean(CommandParam)
    Case aCP__each_char_is_separator
         moTz.env_each_char_is_separator = Make_Boolean(CommandParam)
    Case aCP__SKIP_PROJECT
         moAc.env_SKIP_PROJECT = Make_Boolean(CommandParam)
    Case aCP__SEPARATORS_ARE_GLOBAL
         moTz.env_separators_are_global = Make_Boolean(CommandParam)
    Case aCP__no_change_outside_result
         moAc.env_no_change_outside_result = Make_Boolean(CommandParam)
    Case aCP__NATIVE_SEPARATORS
         moTz.env_native_separators = Make_Boolean(CommandParam)
    Case aCP__RECOGNIZE_NUMBERS
         moTz.env_recognize_numbers = Make_Boolean(CommandParam)
    Case aCP__WORD_CASE_SENSETIVE
         moDlg.env_word_case_sensetive = Make_Boolean(CommandParam)
    Case aCP__KEYWORD_CASE_SENSETIVE
         moTz.env_keyword_case_sensetive = Make_Boolean(CommandParam)
    Case aCP__MAKE_INDENT_AT_EACH_STATE
         env_make_indent_at_each_state = Make_Boolean(CommandParam)
    Case aCP__SEPARATOR_CASE_SENSETIVE
         moTz.env_separator_case_sensetive = Make_Boolean(CommandParam)
    Case aCP__TZ_STRIP_QMARKS
         moTz.tz_strip_qmarks = Make_Boolean(CommandParam)
    
    Case aCP__TZ_WORD_CASE: moTz.tz_word_case = UCase(CommandParam)
    Case aCP__TZ_SEPARATOR_CASE: moTz.tz_separator_case = UCase(CommandParam)
    Case aCP__TZ_KEYWORD_CASE: moTz.tz_keyword_case = UCase(CommandParam)
    Case aCP__TZ_STRING_CASE: moTz.tz_string_case = UCase(CommandParam)
    Case aCP__TZ_ID_CASE: moTz.tz_id_case = UCase(CommandParam)
        
    Case aCP__TZ_CONV_STR: moTz.tz_conv_str = UCase(CommandParam)
    
    Case aCP__AllowOrphanStates
         moTz.env_AllowOrphanStates = Make_Boolean(CommandParam)

    Case aCP__OUTPUT_TEXT_TO_CONSOLE
         moPr.output_text_to_console = Make_Boolean(CommandParam)
    
    Case aCP__SAVE_FILE_MODE
         moAc.env_save_file_mode = Make_Boolean(CommandParam)
    Case aCP__BLOCK_HTMLENCODING
         moPr.BlockHTMLEncoding = Make_Boolean(CommandParam)


    Case aCP__ClearGlobalQueue: moDlg.CleanQueueAndCondition

  'rare commands:

  'extremely rare commands:
  
     'igonre par:
     Case aCP__RESTART_PROJECT: moAc.RESTART_PROJECT_AT_THE_END_flag = True
  
     Case aCP__SUSPEND
               moDlg.suspended = Make_Boolean(CommandParam)
     Case aCP__DEBUG: moDlg.SetDebug Make_Boolean(CommandParam)
     Case aCP__DDEBUG: moDlg.SetDdebug Make_Boolean(CommandParam)
                       'If ddeb Then deb = True

     Case aCP__PDEBUG: pdeb = Make_Boolean(CommandParam)
                       If pdeb Then moDlg.SetDebug True
     
     'ignores parameter:
     Case aCRP__END_TEXT, aCRP__END_TEXT2:  moDlg.flag_TEXT_STOPPED = True
     'ignores par:
     Case aCRP__STOP: moAc.flag_PROJECTS_STOPPED = True
                     moDlg.flag_TEXT_STOPPED = True

    'ignores parameter:
    Case aCP__HELP, aCP__HELP2:  moPr.output_help

Case Else '>>select -1 Select Case CommandToRun
 
   '>>in  select 0 Select Case UCase(Left(CommandToRun, 4))
   Select Case UCase(Left(CommandToRun, 4))
     Case "INCL" '= UCase(CommandToRun) Then
        'ws = moFT.Umbrella & "\" & LocalPathSubmitted
        GoSub PrepareOper2Value
        If ":" = Mid(Oper2PreValue, 2, 1) Then
           ws = read_bin_loose(Oper2PreValue)
        Else
           ws = moFt.abs_umbrella_for_include & "\" & Oper2PreValue
           ws = read_bin_loose(ws)
        End If
        'insert included file:
        'if rawpasrse_StashedFirstPosition is not set
        '  when "include" command is issued, then use motz.mups:
        If 0 = moTz.rawparse_StashedFirstPosition Then _
           moTz.rawparse_StashedFirstPosition = moTz.muPsn
        If moTz.rawparse_StashedFirstPosition > 1 Then
           NewPos = moTz.rawparse_StashedFirstPosition
           moTz.MSourceText = Left(moTz.MSourceText, _
                         moTz.rawparse_StashedFirstPosition - 1) & ws & _
                         Mid(moTz.MSourceText, moTz.muPsn)
        Else
           NewPos = 1
           moTz.MSourceText = ws & Mid(moTz.MSourceText, moTz.muPsn)
        End If
        '"drop" value to preserve it to influence
        '       next call:
        moTz.muPsn = NewPos
        moTz.rawparse_StashedFirstPosition = 0
        
     '>>in  select 0 Select Case UCase(Left(CommandToRun, 4))
     Case "SAVE" '= Left(UCase(CommandToRun), 4) Then
         'don't save in screen-project:
         GoSub PrepareOper2Value
         If "Y" <> moAc.SaveResultsToDisk Or (Not moAc.env_save_file_mode) _
            Then GoTo NeverSaveBlockEnd
         'syntax ..SAVE[$[var=].parameter
         '       if no $      ==> var = out
         '          empty var ==> var = token
         If Mid(CommandToRun, 5, 1) = "$" Then
            'save var
            variable = Mid(CommandToRun, 6)
         Else
            variable = "out"
         End If
         variable = moVr.var_Get(variable)
         If ":" = Mid(Oper2PreValue, 2, 1) Then
            'abs path submitted then
            file_name = Oper2PreValue
         ElseIf "" <> moFt.abs_umbrella_for_save Then
            file_name = moFt.abs_umbrella_for_save & "\" & Oper2PreValue
         Else
            GoTo NeverSaveBlockEnd
         End If
         'this reports execption but they sink here:
         ws = f_SaveProtectively( _
                file_name, _
                variable, _
                moFt.Umbrella_plus_shield, _
                moAc.env_no_change_outside_result)
         If "" <> ws Then moPr.PrintL ws
         
    '>>in  select 0 Select Case UCase(Left(CommandToRun, 4))
    Case "MKDI" '= Left(UCase(CommandToRun), 5) Then
          GoSub PrepareOper2Value
         'don't create in screen-project:
         If "Y" <> moAc.SaveResultsToDisk Or (Not moAc.env_save_file_mode) _
            Then GoTo NeverSaveBlockEnd
         If ":" = Mid(Oper2PreValue, 2, 1) Then
            'abs path submitted then
            file_name = Oper2PreValue
         ElseIf "" <> moFt.abs_umbrella_for_save Then
            file_name = moFt.abs_umbrella_for_save & "\" & Oper2PreValue
         Else
            GoTo NeverSaveBlockEnd
         End If
         'protect from creation outside of RESULT_FOLDER:
         ws = MakeFolderTreeP( _
                 file_name, _
                 moFt.Umbrella_plus_shield, _
                 moAc.env_no_change_outside_result)
         If "" <> ws Then moPr.PrintL ws
         
    '>>in  select 0 Select Case UCase(Left(CommandToRun, 4))
    Case "READ" '= Left(UCase(CommandToRun), 4) Then
         'syntax ..SAVE[$[var=].parameter
         '       if no $      ==> var = in
         '          empty var ==> var = token
         GoSub PrepareOper2Value
         If Mid(CommandToRun, 5, 1) = "$" Then
            'save var
            variable = Mid(CommandToRun, 6)
         Else
            variable = "in"
         End If
         If ":" = Mid(Oper2PreValue, 2, 1) Then
            'abs path submitted then
            '--++20060210TooStrongExceptionOfReadingFile:
            'In proc_Command
            moVr.var_Set variable, read_bin_loose(Oper2PreValue)
            'Think of read_f_warn ...
         Else
            file_name = moFt.abs_umbrella_for_include & "\" & Oper2PreValue
            moVr.var_Set variable, read_bin_loose(file_name)
         End If
         
    '>>in  select 0 Select Case UCase(Left(CommandToRun, 4))
    Case "FLEN" '= Left(UCase(CommandToRun), 4) Then
         'syntax ..FLEN[$[var=].parameter
         '       if no $      ==> var = token
         '          empty var ==> var = token
         GoSub PrepareOper2Value
         If Mid(CommandToRun, 5, 1) = "$" Then
            'put value to var
            variable = Mid(CommandToRun, 6)
         Else
            variable = "token"
         End If
         If ":" = Mid(Oper2PreValue, 2, 1) Then
            'abs path submitted then
            moVr.var_Set variable, FileLen(Oper2PreValue)
         Else
            file_name = moFt.abs_umbrella_for_include & "\" & Oper2PreValue
            moVr.var_Set variable, FileLen(file_name)
         End If
         
     '>>in  select 0 Select Case UCase(Left(CommandToRun, 4))
     Case Else
     
         '>>select 1  Select Case Left(UCase(CommandToRun), 5)
         Select Case Left(UCase(CommandToRun), 5)
     
           Case "CLOSE"
                moDv.CloseVariable Mid(CommandToRun, 7)
           Case "ROPEN", "OPEN$", "WOPEN"
              GoSub PrepareOper2Value
              wi = InStr(CommandToRun, "$")
              If 0 = wi Then
                 GoTo NeverSaveBlockEnd
              Else
                 variable = Mid(CommandToRun, wi + 1)
              End If
              
              WOpenOption = Left(UCase(CommandToRun), 1)
              
              If ":" = Mid(Oper2PreValue, 2, 1) Then
                 'abs path submitted then
                 abs_name_prepared = Oper2PreValue
              Else
                 Select Case WOpenOption
                   Case "R"
                     If "" = moFt.abs_umbrella_for_include Then _
                        GoTo NeverSaveBlockEnd
                     abs_name_prepared = _
                         moFt.abs_umbrella_for_include _
                         & "\" & Oper2PreValue
                   Case "W", "O"
                     'no path - no opening:
                     If "" = moFt.abs_umbrella_for_save Then _
                        GoTo NeverSaveBlockEnd
                     abs_name_prepared = moFt.abs_umbrella_for_save & _
                                         "\" & Oper2PreValue
                 End Select
              End If
              '>>select 1  Select Case Left(UCase(CommandToRun), 5)
             
             

              Select Case WOpenOption  '>>select 2 Select Case WOpenOption
                 Case "W"
                     If "Y" <> moAc.SaveResultsToDisk Or _
                        (Not moAc.env_save_file_mode) _
                        Then WOpenOption = "P" ' protected
                     If "P" <> WOpenOption And _
                        moAc.env_no_change_outside_result Then
                        ws = OutOfScope(moFt.Umbrella_plus_shield, _
                                        abs_name_prepared)
                        If "" <> ws Then
                           WOpenOption = "P"
                          'this reports exception but they sink here:
                           moPr.PrintL ws
                        End If
                     End If
                 Case "O"
                     If "Y" <> moAc.SaveResultsToDisk Or _
                        (Not moAc.env_save_file_mode) _
                        Then WOpenOption = "R" 'downsize to read-only
              End Select '>>select 2 Select Case WOpenOption
              
              moDv.OpenVariable variable, abs_name_prepared, WOpenOption
              
         Case "OLEN$" '>>select 1  Select Case Left(UCase(CommandToRun), 5)
              moDv.OpenFileLen Mid(CommandToRun, 6)
         

         Case Else '>>select 1  Select Case Left(UCase(CommandToRun), 5)
            proc_Command = False
       End Select  '>>select 1  Select Case Left(UCase(CommandToRun), 5)
    End Select     '>>select 0  Select Case UCase(Left(CommandToRun, 4))
End Select         '>>select -1 Select Case CommandToRun
NeverSaveBlockEnd:
Exit Function



'===========================================================
PrepareOper2Value:
Oper2PreValue = CommandParam
If c__PlainText = ResultedTextType Then
'-----------------------------------------------------------
   If 0 = Len(CommandParam) Then
      Oper2PreValue = moVr.var_Get(varn_TOKEN)
   Else
      wi = Asc(Left(CommandParam, 1))
      If wi < 48 Or wi > 57 Then
         '--------------------------------------------------
         ' first is not a digit => interpret as a variable:
         Oper2PreValue = moVr.var_Get(Oper2PreValue)
         '--------------------------------------------------
      End If
   End If
End If
Return
'===========================================================



End Function



Public Sub switchBasicEnvironment(Which$)
Select Case UCase(Which)
  Case "VBSCRIPT"

moAc.env_no_change_outside_result = True
moTz.env_native_separators = True
moTz.env_separators_are_global = True
moTz.env_recognize_numbers = True
moDlg.env_word_case_sensetive = False
moTz.env_keyword_case_sensetive = False
env_make_indent_at_each_state = False
moTz.env_separator_case_sensetive = False
moTz.env_each_char_is_separator = False

env_output_case = ""

moTz.env_recongnize_strings = True
moTz.tz_strip_qmarks = False

moTz.tz_word_case = "L"
moTz.tz_separator_case = "L"
moTz.tz_id_case = "L"
moTz.tz_keyword_case = "L"
moTz.tz_string_case = ""

moTz.tz_conv_str = "P"
   
   Case "GENERIC"
moAc.env_no_change_outside_result = True
moTz.env_native_separators = True
moTz.env_separators_are_global = True
moTz.env_recognize_numbers = False
moDlg.env_word_case_sensetive = True
moTz.env_keyword_case_sensetive = True
env_make_indent_at_each_state = False
moTz.env_separator_case_sensetive = True
moTz.env_each_char_is_separator = False

env_output_case = "N"
moPr.output_text_to_console = True

moTz.env_recongnize_strings = False
moTz.tz_strip_qmarks = False

moTz.tz_word_case = ""
moTz.tz_separator_case = ""
moTz.tz_id_case = ""
moTz.tz_keyword_case = ""
moTz.tz_string_case = ""

moTz.tz_conv_str = ""

   Case "HTML"
moAc.env_no_change_outside_result = True
moTz.env_native_separators = False
moTz.env_separators_are_global = False
moTz.env_recognize_numbers = False
moDlg.env_word_case_sensetive = True
moTz.env_keyword_case_sensetive = True
env_make_indent_at_each_state = False
moTz.env_separator_case_sensetive = True
moTz.env_each_char_is_separator = False

env_output_case = "N"

moTz.env_recongnize_strings = False
moTz.tz_strip_qmarks = False

moTz.tz_word_case = ""
moTz.tz_separator_case = ""
moTz.tz_id_case = ""
moTz.tz_keyword_case = ""
moTz.tz_string_case = ""

moTz.tz_conv_str = ""

End Select

End Sub


'INPUT: S - command; PP - parameter;
'       PP - must be already deescaped if necessary;
'            deescaping is done in proc_Queue
'       Parameter_Status - P - Quouted string - constant; p-variable name;
'
'OUTPUT: returns proc_Program = False if program was not performed;
'
's may be +moo,boo    =x,y
'depending on +,-, ... or other word s can be arithmetic
'
Function proc_Program(Com_mand$, PP$, Parameter_Status$) As Boolean

Dim Oper_Ation$

Dim Oper1$, Oper2$
Dim Oper1PreValue$, Oper1Number
Dim Oper2PreValue$, Oper2Number
Dim ws$, WSS$, w1$, w2$, w3$, w4$
Dim wi&, WII&

Dim xNum&, xMess$, aMess$
On Error GoTo he

proc_Program = True
'empty command is skipped in action-queue:
If Com_mand = "" Then Exit Function

Oper_Ation = Left(Com_mand, 1)

espot = "Selecting Operation"
Select Case Oper_Ation

    'string operations and string comparisions:
    Case "=", "?", "&", "{", "}", "#", "@", "[", "]", alph__ListVariableOperation
         '"operations on strings"
         GoSub PrepareOper2Value
         GoSub PrepareOper1
    
    'number-to-string operation: char(Oper2)
    Case "1", "2", "4", "6", "8"
         GoSub PrepareOper2Value
         GoSub DigityOper2Value
         GoSub PrepareOper1
    
    'arithmetical operations and arithmetical comparisions:
    Case "+", "-", "*", "^", "\", "!", "/", "|", "%", ":", _
         ">", "<"
         GoSub PrepareOper2Value
         GoSub DigityOper2Value
         GoSub PrepareOper1
         GoSub DigityOper1
    Case Else
         'job is not done yet: report this to caller:
         proc_Program = False
         Exit Function
End Select
     



 


'MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
' ACTUAL OPERATIONS BEGIN HERE:
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm

espot = "Performing Operation"
Select Case Oper_Ation
                
    '-------------------------------------------------------------------
    '    true string operations
    Case "=":   moVr.var_Set Oper1, Oper2PreValue
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "&": moVr.var_Set Oper1, Oper1PreValue & Oper2PreValue
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
              'concatenate strings in reverse order:
    Case "@": moVr.var_Set Oper1, Oper2PreValue & Oper1PreValue
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    'this case is cloned from "&"
    Case "]": moVr.var_Set Oper1, StrReverse(Oper2PreValue)
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "#":   'convert to asc value:
                Select Case Len(Oper2PreValue)
                    'Case 0:  'do nothing, let user worry why ...
                    Case 1   'take byte or ASCII
                         moVr.var_Set Oper1, CStr(Asc(Left(Oper2PreValue, 1)))
                         If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
                    Case 2:  'take big-endian word:
                         moVr.var_Set Oper1, CStr( _
                                        Asc(Left(Oper2PreValue, 1)) * 256 + _
                                        Asc(Mid(Oper2PreValue, 2, 1)))
                    Case 4:  'take big-endian double word:
                         wi = Asc(Left(Oper2PreValue, 1))
                         w1 = wi Mod 128
                         WII = ((w1 * 256 + _
                                Asc(Mid(Oper2PreValue, 2, 1))) * 256 + _
                                Asc(Mid(Oper2PreValue, 3, 1))) * 256 + _
                                Asc(Mid(Oper2PreValue, 4, 1))
                         If wi > 127 Then WII = -WII
                         moVr.var_Set Oper1, CStr(WII)
                                         
                End Select
    'this case is cloned from "#"
    Case "[":   'convert to asc value:
                Select Case Len(Oper2PreValue)
                    'Case 0:  'do nothing, let user worry why ...
                    Case 1   'take byte or ASCII
                         moVr.var_Set Oper1, CStr(Asc(Left(Oper2PreValue, 1)))
                         If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
                    Case 2:  'take big-endian word:
                         moVr.var_Set Oper1, CStr( _
                                        Asc(Mid(Oper2PreValue, 2, 1)) * 256 + _
                                        Asc(Mid(Oper2PreValue, 1, 1)))
                    Case 4:  'take big-endian double word:
                         wi = Asc(Mid(Oper2PreValue, 4, 1))
                         w1 = wi Mod 128
                         WII = ((w1 * 256 + _
                               Asc(Mid(Oper2PreValue, 3, 1))) * 256 + _
                               Asc(Mid(Oper2PreValue, 2, 1))) * 256 + _
                               Asc(Mid(Oper2PreValue, 1, 1))
                         If wi > 127 Then WII = -WII
                         moVr.var_Set Oper1, CStr(WII)
                End Select
    '======================================================================================================
    Case alph__ListVariableOperation, "{", "}" '    LIST OPERATIONS
    '------------------------------------------------------------------------------------------------------
         'schema:   "....^...vl...."  ---> "....^^...^\..." & vl
         'find substituted string:
         Oper2PreValue = Replace( _
                  Replace(Oper2PreValue, alph__ListVariableEscape, alph__ListVariableEscape & alph__ListVariableEscape), _
                  alph__ListVariableSeparator, alph__ListVariableEscape & alph__ListVariableHiddenSeparator _
                  ) & alph__ListVariableSeparator
                           
         Select Case Oper_Ation
             Case alph__ListVariableOperation
                'add string to the list only if it still does not exist there:
                '"need" to put lf before is ugly:
                If InStr(alph__ListVariableSeparator & _
                         Oper1PreValue, _
                         alph__ListVariableSeparator & _
                         Oper2PreValue) = 0 Then _
                   moVr.var_Set Oper1, Oper1PreValue & Oper2PreValue
             Case "{":  'case sensetive belonging to a list Oper1
                If 0 < InStr(alph__ListVariableSeparator & Oper1PreValue, _
                   alph__ListVariableSeparator & Oper2PreValue) Then
                   moDlg.oCondition = "1"
                Else
                   moDlg.oCondition = "2"
                End If
             Case "}":  'ignore case; test belonging to a list Oper1
                If 0 < InStr( _
                   UCase(alph__ListVariableSeparator & Oper1PreValue), _
                   UCase(alph__ListVariableSeparator & Oper2PreValue)) Then
                   moDlg.oCondition = "1"
                Else
                   moDlg.oCondition = "2"
                End If
         End Select
     'COMPARISIONS ON STRINGS: ------------------------
     Case "?"
              If Oper1PreValue = Oper2PreValue Then
                 moDlg.oCondition = "1"
              Else
                 moDlg.oCondition = "2"
              End If
      
    '===================================================================
                
    Case "1":  'convert to chr value:
               moVr.var_Set Oper1, CStr(Chr(Oper2Number))
               If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "2", "6"
           'abs makes protection,
           'if Oper2Number is negative,
           '    this means input is wrong;
           wi = Abs(Oper2Number)
           WSS = Chr(wi \ 256)
           ws = Chr(wi Mod 256)
           Select Case Oper_Ation
              Case "2": moVr.var_Set Oper1, WSS & ws 'big-endian
              Case "6": moVr.var_Set Oper1, ws & WSS 'little-endian
           End Select
    Case "4", "8"
           'abs makes protection,
           'if Oper2Number is negative,
           '    this means input is wrong;
           '
           
           wi = Abs(Oper2Number) 'This restricts to 2147483647
           
           'KK.--++20051022Division16 bug: must be 65536
           'was:
           'WII = wi \ 16777216
           'wi = wi - (WII * 16777216)
           'If Oper2Number < 0 Then WII = WII + 16777216
           'fix:
           WII = wi \ 65536
           wi = wi - (WII * 65536)
           If Oper2Number < 0 Then WII = WII + 32768
          
           
           'now two tokens wii,major, and
           '               wi, minor, are ready
           w4 = Chr(WII \ 256)   'Major bits
           w3 = Chr(WII Mod 256) 'Minor in Major
           w2 = Chr(wi \ 256)    'Major in Minor
           w1 = Chr(wi Mod 256)  'Minor
           Select Case Oper_Ation
              Case "4": moVr.var_Set Oper1, w4 & w3 & w2 & w1 'big-endian
              Case "8": moVr.var_Set Oper1, w1 & w2 & w3 & w4 'little-endian
           End Select
                
    Case "+": moVr.var_Set Oper1, CStr(Oper1Number + Oper2Number)
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "-": moVr.var_Set Oper1, CStr(Oper1Number - Oper2Number)  'kk.17.3.j
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "*": moVr.var_Set Oper1, CStr(Oper1Number * Oper2Number)
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "/": moVr.var_Set Oper1, CStr(Oper1Number / Oper2Number)
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "\": moVr.var_Set Oper1, CStr(CLng(Oper1Number \ Oper2Number))
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "%": moVr.var_Set Oper1, CStr(Oper1Number Mod Oper2Number)
                If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "^": moVr.var_Set Oper1, CStr(Oper1Number Xor Oper2Number)
              If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "|": moVr.var_Set Oper1, CStr(Oper1Number Or Oper2Number)
              If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case ":": moVr.var_Set Oper1, CStr(Oper1Number And Oper2Number)
              If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
    Case "!": moVr.var_Set Oper1, CStr(Not Oper2Number)
              If pdeb Then moPr.prn_NSI Oper1 & "=" & moVr.var_Get(Oper1)
              
    'COMPARISIONS ON NUMBERS ===================================
    Case ">":
              If Oper1Number > Oper2Number Then
                 moDlg.oCondition = "1"
              Else
                 moDlg.oCondition = "2"
              End If
    Case "<"
              If Oper1Number < Oper2Number Then
                 moDlg.oCondition = "1"
              Else
                 moDlg.oCondition = "2"
              End If
    'ef COMPARISIONS ON NUMBERS ================================
              
End Select

ExitFunction:   Exit Function


'MMMM  SUBROUTINES  MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM


'===========================================================
PrepareOper2Value:
espot = "Prepare Operand 2 Value"
Oper2 = PP
Oper2PreValue = Oper2
' SCHEMA-IDENTIFICATOR TEXT
If c__PlainText = Parameter_Status Then
'-----------------------------------------------------------
   If "" = Oper2 Then
      Oper2 = varn_TOKEN
      Oper2PreValue = moVr.var_Get(Oper2)
   Else
      wi = Asc(Left(Oper2, 1))
      If wi < 48 Or wi > 57 Then
         '--------------------------------------------------
         ' first is not a digit => interpret as a variable:
         Oper2PreValue = moVr.var_Get(Oper2)
         '--------------------------------------------------
      End If
   End If
End If
Return
'===========================================================

   
DigityOper2Value:
   ' Oper2PreValue is ready
   ' It came from variable or from string or numeric constant.
   ' But, now, it is a string value.
   
   'for case of arithmetical operations,
   'convert this value to a proper number
   
   espot = "Digitizing Operand 2 Value"
   If "" = Oper2PreValue Then
      Oper2Number = 0
   Else
      If "/" = Oper_Ation Then
         On Error GoTo xOper2NotConverted
         Oper2Number = CDbl(Oper2PreValue)
         On Error GoTo he
      Else
         On Error GoTo xOper2NotConverted
         Oper2Number = CLng(Oper2PreValue)
         On Error GoTo he
      End If
   End If
Return



PrepareOper1:
  espot = "Prepare Operand 1 Value"
  Oper1 = Mid(Com_mand, 2)
  If Oper1 = "" Then Oper1 = varn_TOKEN
  Oper1PreValue = moVr.var_Get(Oper1)
Return
      
      
DigityOper1:
  If "" = Oper1PreValue Then
     Oper1Number = 0
  Else
     On Error GoTo xOper1NotConverted
     If "/" = Oper_Ation Then
        Oper1Number = CDbl(Oper1PreValue)
     Else
        Oper1Number = CLng(Oper1PreValue)
     End If
     On Error GoTo he
  End If
Return
      


'MMMM  EXCEPTIONS  MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM

xOper2NotConverted:
            
   xNum = Err.Number
   xMess = Err.Description
   Resume xxOper2NotConverted
   
xxOper2NotConverted:
   On Error GoTo 0
  If c__PlainText <> Parameter_Status Then
     ws = "Operand 2 came from the (unescaped)string." & ve
  Else
     ws = "Operand 2 is a variable or numeric constant." & ve
  End If
      
  e_raise " In operation: """ & Com_mand & """," & ve & _
         " Operand 2: """ & Oper2 & """" & ve & _
         " has value: """ & Oper2PreValue & """" & ve & _
         " which is not a long or double number." & ve & _
         ws

xOper1NotConverted:

   xNum = Err.Number
   xMess = Err.Description
   Resume xxOper1NotConverted
   
xxOper1NotConverted:
   On Error GoTo 0
   e_raise " In operation: " & Com_mand & "," & ve & _
           " Operand 1: """ & Oper1 & """" & ve & _
           " has value: """ & Oper1PreValue & """" & ve & _
           " which is not a long or double number."


'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
he:
xNo = Err.Number
xMe = CStr(xNo) & " " & Err.Description
Resume xNext
xNext:
    
aMess = "In Operation: """ & Oper_Ation & """" & ve & _
        "Operand 1 """ & Oper1 & """" & _
        " Operand 2=""" & Oper2 & """" & ve

On Error GoTo 0
'will stop texts:
e_raise xMe & ve & aMess & _
        "Location in procedure: " & espot & ve
'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx




End Function


Public Sub SetMoDialog(dlg As CDialog)
Set moDlg = dlg
End Sub

Private Sub Class_Initialize()
 deb = False
 pdeb = False
 indent_body = "   "
End Sub


Private Sub Class_Terminate()

Set moDlg = Nothing
Set moPr = Nothing
Set moDv = Nothing
Set moVr = Nothing
Set moTz = Nothing
Set moAc = Nothing
Set moFt = Nothing

End Sub


