Attribute VB_Name = "web_auxiliary"
Option Explicit

'Original refers to StartUp set
'  in original, unconverted, application.
'  Original startup is set
'     for VB4 in SDK/menu/Tools/Options/Project/
'             StartUp Form
'             via Sub Main or one of the forms
'     for VB6 in SDK from Projects window
'             via Project Properties/General/
'                 Start Up Object
Public web_OriginalStartUpDone$


Public web_TimersCompleted$
'for debug:
Public web_c As web_frmConsole
Public web_SID$  'session id
Public web_EnteredDestrNoTimers$ 'blocker

Public web_LoadedForms$
Public web_LoadedFormsArray() As Form

Public web_InformTerminationToClient As Boolean   '0/-1  for False/True

'Public web_IAmBack As Boolean
'Public web_YouCanGo As Boolean
'redundant if timer does not allow recursion:
'Public web_TimerIsBusy As Boolean
'temporarily 10 seconds:
'Public web_ResponseTo&
'Public web_ServerDidNotComplete As Boolean
'Public web_ReleaseWebClassToGo As Boolean
'Public web_TimerIsSpinning As Boolean
Public web_FormsUnloading$


'Public web_ExceptionMessage$
'Public web_Msg$

'provided as flag to be used by programmer
'for further code modifications:
Public web_AllowLocal$  '"W" or "L"

'ME    gloEorD$







Public Declare Function GetTickCount Lib "kernel32" () As Long

Public Sub web_d(s$)
  If Not web_c Is Nothing Then web_c.t s
End Sub
Public Sub web_FormVis(ob As Form, v&)
   'bug: ob.web_mFormVis v
   ob.web_mSetVis ob, v
End Sub

Public Sub web_SetVis(ob As Object, v&)
  ob.Parent.web_mSetVis ob, v
End Sub

Public Function web_GetVis&(ob As Object)
  web_GetVis = ob.Parent.web_mGetVis(ob)
End Function

'<<<*>>> To Replace "End" Statement
Public Sub web_End()

 Close
 
 'this is a flag for forms and
 'web_class:
 'this flag may be put
 'to all unload events in forms
 'to block any unload code:
 web_InformTerminationToClient = True

 Destroy_IfNoTimers
 'web_DestroyAllForms
 
End Sub



'micro helper:
Public Sub mic_BuildLoadedForms()
   Dim frm As Form, I&
   web_LoadedForms = ""
   ReDim web_LoadedFormsArray(0)
   For Each frm In Forms
       web_LoadedForms = _
           web_LoadedForms & frm.Name & vbCrLf
       I = UBound(web_LoadedFormsArray) + 1
       ReDim Preserve web_LoadedFormsArray(I)
       Set web_LoadedFormsArray(I) = frm
   Next
   web_d "Loaded forms: " & vbCrLf & _
         web_LoadedForms
End Sub

'micro helper:
Public Sub web_DestroyAllForms()
  Dim s1$, s2$
  'to avoid recursion:
  If "T" = web_FormsUnloading Then Exit Sub
  web_d "Unloading all forms ... "
  web_FormsUnloading = "T"
  mic_BuildLoadedForms
  web_d "Unloaded forms have been built."
  Do While UBound(web_LoadedFormsArray) > 0
    
     'Unload startup form only in "last order"
     'to prevent presumed original order of
     'unload:
     s1 = web_LoadedFormsArray(1).Name
     If UBound(web_LoadedFormsArray) > 1 And _
        UCase("REPLACEMEStartUpForm") = _
        UCase(s1) Then
          s2 = web_LoadedFormsArray(2).Name
          web_d "Unloading " & s2
        Unload web_LoadedFormsArray(2)
        web_d "Done:" & s2
     Else
        web_d "Unloading " & s1
        Unload web_LoadedFormsArray(1)
        web_d "Done: " & s1
     End If
      
     'interference with
     'another destroyers eliminated:
     mic_BuildLoadedForms
  Loop
  web_d "All forms unloaded ... "

End Sub

'<<<*>>> ListBox helper
Public Function web_Display_ListBox$( _
                ob As Control)
  Dim I&, res$, ws$
  If ob.ListCount = 0 Then Exit Function
  With ob
    For I = 0 To .ListCount - 1
       ws = ""
       If I = .ListIndex Then ws = " selected "
       res = res & _
           "<option value=""" & I & """" & ws & " />" & _
             .List(I) & vbCrLf
    Next
  End With
  web_Display_ListBox = res
End Function


Public sub web_r(s$)
'why this sub?
web_d s
end sub



Public Function Destroy_IfNoTimers()
   
Dim Act_iveTimers$

If "Y" = web_EnteredDestrNoTimers Then _
   Exit Function
web_EnteredDestrNoTimers = "Y"

web_d "Entered Destroy_IfNoTimers"
'=========================================

'  frmWait.tmrAni_Timer

'-----------------------------------------
'another garbage-timers:
If "" <> pp_WaitTimer Then
   web_d "frmWait.tmrAni_Timer is on."
   Act_iveTimers = Act_iveTimers & _
                   pp_WaitTimer & vbCrLf
End If
'flag="W"/"" for frmWait.tmrAni_Timer\
'=========================================





'=========================================

'   frmMain.timer1_Timer

'-----------------------------------------
'pseudo processes in Main
If "" <> pp_MainTimer Then
   web_d "frmMain.timer1_Timer is on."
   Act_iveTimers = Act_iveTimers & _
                   pp_MainTimer & vbCrLf
End If
'"W" is a marker
'"" is not-active marker
'========================================



'========================================

'   frmBatMgr.tmrSetup_Timer

'----------------------------------------
If "" <> pp_BatMgrTimer Then
   web_d "frmBatMgr.tmrSetup_Timer is on."
   Act_iveTimers = Act_iveTimers & _
                   pp_BatMgrTimer & vbCrLf
End If
'pp_BatMgrTimer = "W" is a marker
'pp_BatMgrTimer = ""  is a neutral
'========================================



'========================================

'frmCancel.Sub timer1_Timer

'----------------------------------------
' flag:
'pp_MainTimer = "W"
If "" <> pp_MainTimer Then
   web_d "frmCancel.Sub timer1_Timer is on."
   Act_iveTimers = Act_iveTimers & _
                   pp_MainTimer & vbCrLf
End If
'========================================




'============================================

'frmCredit.tmrCreditCard_Timer

'--------------------------------------------
If "" <> pp_CreditCardCancelTimer Then
   web_d "frmCredit.tmrCreditCard_Timer is on."
   Act_iveTimers = Act_iveTimers & _
          pp_CreditCardCancelTimer & vbCrLf
End If
'ccr_FinalParserInTimer = "Y"/""
'SET IN CCReaderAcceptor.ccr_fTestDataInTimer
'============================================


'========================================

'  frmCredit.tmrMain _ Timer()

'----------------------------------------
If "" <> ccr_MainTimerWork Then
   web_d "ccr_MainTimerWork is on."
   Act_iveTimers = Act_iveTimers & _
                 ccr_MainTimerWork & vbCrLf
End If
'ccr_MainTimerWork '"Y"/"" = marker
'(If ccr_FinalParserInTimer <> "" _
'    Then Exit Sub)
'========================================


If "" = Act_iveTimers Then
   web_d "No active timers."
   web_DestroyAllForms
   Destroy_IfNoTimers = ""
Else
   Destroy_IfNoTimers = Act_iveTimers
End If

web_d "Quit Destroy_IfNoTimers."
web_EnteredDestrNoTimers = ""
End Function

