Attribute VB_Name = "FileHandlerBasic"

Option Explicit

Private xMe$, xNo&



Private Sub prEUp(s$)
  Err.Raise xNo, , xMe & ve & s
End Sub

'be - binary, empty if exception
'
Function read_bin_loose$(Full_File_Name$)
Dim handler%, result$, I&

read_bin_loose = ""

On Error GoTo ExitWhenException

'this line prevents from creating a file:
If Dir(Full_File_Name) = "" Then Exit Function
If FileLen(Full_File_Name) = 0 Then Exit Function

handler = FreeFile
 
Open Full_File_Name For Binary As #handler
'this code looks like a garbage:
I = LOF(handler)
If I = 0 Then
   Close Full_File_Name
   Exit Function
End If

result = Space(I)
Get #handler, 1, result
Close #handler
read_bin_loose = result

ExitWhenException:

'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'--++20060210RunTimeExceptionAtLooseRead:
'Added
Exit Function
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

End Function

'
'returns parent full name;
'   allowed: c:moo
'            c:\too
'            c:\goo\too
'
Function separate_path$(Full_File_Name$)
    Dim path_end%
    path_end = InStrRev(Full_File_Name, "\")
    If path_end > 0 Then
       separate_path = Left(Full_File_Name, path_end - 1)
    Else
       path_end = InStr(Full_File_Name, ":")
       If 0 = path_end Then
          separate_path = ""
       Else
          separate_path = Left(Full_File_Name, path_end)
       End If
    End If
End Function
Sub DeleteIfExists(file_name$)
  
  Dim ws$
  If file_name = "" Then Exit Sub
  On Error GoTo he
  ws = Dir(file_name)
  If ws <> "" Then Kill file_name
  
  Exit Sub
  
he:
  xMe = Err.Description
  xNo = Err.Number
  Resume xNext
xNext:
  On Error GoTo 0
  prEUp "when deleting `" & file_name & "`"

End Sub






Function read_f$(file_to_read$)
Dim handler%, result$, I&

handler = FreeFile
On Error GoTo open_error
 
' KK: this creates a file; should not;

Open file_to_read For Binary As #handler
' this statement has problems with file length about 90K:
 result = Space(LOF(handler))
 I = Len(result)
 
 If I = 0 Then
     read_f = ""
     Close #handler
     Exit Function
 Else
 
     On Error GoTo read_error
     Get #handler, 1, result
     Close #handler
     read_f = result
     Exit Function

 End If
 
read_error:
  xMe = Err.Description
  xNo = Err.Number
  Resume xNext
xNext:
  On Error GoTo 0
  prEUp "when reading a file `" & _
      file_to_read & "` in `read_f` module"
  
open_error:

  xMe = Err.Description
  xNo = Err.Number
  Resume xNext2
xNext2:
  On Error GoTo 0
  prEUp "when opening a file `" & _
      file_to_read & "` in `read_f` module"
End Function
 

'EXCE raises exceptions
'
'
Sub write_f(file_name$, file_text$)
Dim handler%

handler = FreeFile
If file_text = "" Or file_name = "" Then Exit Sub

'It is not found in documentation:
'   is file erased when 'Open for Output'
'Therefore, to not rely on undocumented
'   features, erase it now:
'Please email you notes to Script At Landkey.net:
On Error GoTo CannotDeleteFile
If Dir(file_name) <> "" Then Kill file_name

On Error GoTo open_error
Open file_name For Output Access Write Shared As handler
  
On Error GoTo write_error

'does not work:
'Put handler, , file_text

'"Output" -
'     even if this mode does not appear
'     good for binary data,
'     this mode seems work excellently
'     with Print statement:
'     may be not fast:
Print #handler, file_text;    ' semicolumn may be vital
                              ' only for append ...
Close #handler

Exit Sub

write_error:
  xMe = Err.Description
  xNo = Err.Number
  Resume xNext
xNext:
  On Error GoTo 0
  prEUp "when writing a file " & ve & _
      file_name & ve & _
      "in ""write_f"" module."

open_error:

  xMe = Err.Description
  xNo = Err.Number
  Resume xNext2
xNext2:
  On Error GoTo 0
  prEUp "when opening a file " & ve & _
      file_name & ve & " in ""write_f"" module."
      
CannotDeleteFile:
      
  xMe = Err.Description
  xNo = Err.Number
  Resume CannotDeleteFile2
CannotDeleteFile2:
  On Error GoTo 0
  prEUp "when deleting before writing to file " & ve & _
      file_name & ve & _
      "in ""write_f"" module."
      
      
End Sub



