Attribute VB_Name = "fileaux"

Option Explicit





Sub append_file_to_file(sf$, rf$)
 Dim sh%, rh%, slength&, rlength&, portion$, espot$
 Dim s_start&, size_to_read&

 On Error GoTo he
 
 espot = "start"
 
 sh = FreeFile
 
 espot = "source"
 Open sf For Binary As #sh
 
 espot = "slength"
 slength = LOF(sh)
 
 espot = "result"
 rh = FreeFile
 Open rf For Append Shared As #rh   ' shared?
 
'espot = "rlength"     ' to display ...
'slength = LOF(rh)
 
'If slength < 60000 Then
'
'    ' not necessary part:
'    espot = "readall"
'    portion = Space(slength)
'    Get #sh, 1, portion
'
'    espot = "write all"
'    Print #rh, portion;'
'
' Else
    
    ' MsgBox sf & "size=" & slength
    
    s_start = 1
    size_to_read = slength - s_start + 1
    
    Do While size_to_read > 0
       
       If size_to_read > 60000 Then size_to_read = 60000
       espot = "read portion; start=" & s_start & " size_to_read=" & size_to_read
    
       portion = Space(size_to_read)
       Get #sh, s_start, portion
       
       espot = "write portion; start=" & s_start & " size_to_read=" & size_to_read
       Print #rh, portion;

       s_start = s_start + size_to_read
       size_to_read = slength - s_start + 1
   
    Loop
    
' End If
 
 espot = "close source file"
 Close #sh
 
 espot = "close result file"    ' definitely too early ...
 Close rh
 
 Exit Sub
 
he: e_up "append_file_to_file: " & vbCrLf & espot & vbCrLf & _
         "source file=`" & sf & "`" & vbCrLf & "result file=`" & rf & "`"
    
End Sub

Sub close_portion(handler%)
    On Error Resume Next
    Close (handler)
    If Err Then e_up "in close_portion"
End Sub

Function initiate_portion%(fn$)
 Dim handler%

 On Error GoTo he
 
 handler = FreeFile
 If Not Dir(fn) Then
    initiate_portion = -1
    Exit Function
 End If
 
 Open fn For Binary As #handler
 initiate_portion = handler
 Exit Function

he:   e_up "when opening a file `" & _
      fn & "in `initiate_portion`"
  
End Function

'be - binary, empty if exception
'
Function read_be$(Full_File_Name$)
Dim handler%, result$, I&

read_f_or_empty = ""

On Error GoTo ExitWhenException

'this line prevents from creating a file:
If Dir(Full_File_Name) = "" Then Exit Function

handler = FreeFile
 
Open file_to_read For Binary As #handler
I = LOF(handler)
If I = 0 Then Exit Function

result = Space(I)
Get #handler, 1, result
Close #handler
read_file = result

ExitWhenException:

End Function

'
' seems useless:
'
Function read_portion_from$(handler%, start_pos&, portion_length&)
 Dim result$
 
 result = Space(portion_length)
 On Error GoTo read_error
 Get #handler, start_pos, result
 read_portion_from = result
 Exit Function
 
read_error:
  e_up "when reading a file whith handler `" & _
  handler & "` in `read_portion_from` module"
End Function


'
' retrieves short file name from full file name
' input string may be empty or may not have  a file name
' in this case, empty string is returned
'
Function separate_file$(Full_File_Name$)
    Dim path_end%
    path_end = instrrevv(Full_File_Name, "\")
    If path_end > 0 Then
       separate_file = Mid(Full_File_Name, path_end + 1)
    Else
       separate_file = Full_File_Name
    End If
    
    'case c:file_name
    path_end = instrrevv(separate_file, ":")
    If path_end > 0 Then
       separate_file = Mid(separate_file, path_end + 1)
    End If
    
    
End Function

'
'returns parent full name;
'
Function separate_path$(Full_File_Name$)
    Dim path_end%
    path_end = instrrevv(Full_File_Name, "\")
    If path_end > 0 Then
       separate_path = Left(Full_File_Name, path_end - 1)
    Else
       separate_path = ""
    End If
End Function

'INPUT:    in_out_FileName          - file name        (may be empty, "\", "\moo...", "...moo\"
'
'OUTPUT:   in_out_FileName          - proper-file-name (may be empty)
'          path_FixAndSplit         - full-file-name   (never empty)
'          ResultedParentPath       - full-parent-name (never empty )
'
'NOTES:    If no root => then App.path is added.
'
'
Function path_FixAndSplit(in_out_FileName$, ResultedParentPath$)
Dim RetFun$
     
AttachRootTo in_out_FileName
RetFun = in_out_FileName
'retfun has : or \\ for sure;
'RetFun does not change:
ResultedParentPath = get_PathedParent(RetFun, in_out_FileName)
path_FixAndSplit = RetFun
     
End Function


Function open_and_append_to_file$(File_Name$, text_to_append$)
    Dim handler%
    
    On Error GoTo open_error
    handler = FreeFile
    Open File_Name For Append Shared As #handler
    On Error GoTo writing_error
    Print #handler, text_to_append
    open_and_append_to_file = "done" & vl
    Close #handler
    Exit Function
    
open_error:
    open_and_append_to_file = "error" & vl & _
    "error opening file `" & File_Name & "`" & ve & _
    Err.Description
    Close #handler
    
writing_error:
    open_and_append_to_file = "error" & vl & _
    "error writing to file `" & File_Name & "`" & ve & _
    Err.Description
    Close #handler
    
End Function
'
'hadles errors using standard VB error handling mechanism
'do not do anything if file name or text_to_append are empty
'
Sub OpenAndAppendToFile(File_Name$, text_to_append$)
    Dim handler%
    
    If File_Name = "" Then Exit Sub
    If text_to_append = "" Then Exit Sub
    
    On Error GoTo open_error
    handler = FreeFile
    Open File_Name For Append Shared As #handler
    On Error GoTo writing_error
    Print #handler, text_to_append
    Close #handler
    Exit Sub
    
open_error:
    Close #handler
    e_up "in OpenAndAppendToFile" & ve & _
    "when opening file `" & File_Name & "`" & ve & _
    Err.Number & ve & Err.Description
    
    
writing_error:
    Close #handler
    e_up "in OpenAndAppendToFile" & ve & _
    "when writing to a file `" & File_Name & "`" & ve & _
    Err.Number & ve & Err.Description
    Close #handler
    
End Sub

Function append_to_file$(handler%, File_Name$, text_to_append$)

    On Error GoTo open_error
    If handler = -1 Then
       handler = FreeFile
       Open File_Name For Append Shared As #handler
    End If
    Print #handler, text_to_append
    append_to_file = "done" & vl
    Exit Function
    
open_error:
    append_to_file = "error" & vl & _
    "error opening file `" & File_Name & "`" & ve & _
    Err.Description
    Close #handler
    handler = -1

End Function





Function close_file$(handler%)
      If handler <> -1 Then
         Close handler
         handler = -1
      End If
End Function


Sub DeleteIfExists(File_Name$)
  Dim WS$
  If File_Name = "" Then Exit Sub
  On Error Resume Next
  WS = Dir(File_Name)
  If Err.Number = 0 Then
     On Error GoTo he
     If WS <> "" Then Kill File_Name
  End If
  
  Exit Sub
he:   e_up "when deleting `" & File_Name & "`"
End Sub



'
'
'
Function read_file$(file_to_read$)
 Dim handler%, result$, I&

 handler = FreeFile
 On Error GoTo open_error
 
 Open file_to_read For Binary As #handler
 result = Space(LOF(handler))
 I = Len(result)
 If I = 0 Then
     read_file = "empty" & vl & "opening error or empty file `" & file_to_read & "`"
     Close #handler
     Exit Function
 
 Else
     
     On Error GoTo read_error
     Get #handler, 1, result
     Close #handler
     read_file = "done" & vl & result
     Exit Function

 End If
  
Exit Function

read_error:
 'read_file = "error" & vl & " error reading file `" & file_to_read & "`" & ve & _
 '             Err.HelpContext & ve & _
 '             Err.Description
 e_up " error reading file `" & file_to_read & "`"
Exit Function

open_error:
 'read_file = "error" & vl & "error opening file `" & file_to_read & "`" & ve & _
 '            Err.Description
 e_up "error opening file `" & file_to_read & "`"

End Function

Function read_f$(file_to_read$)
Dim handler%, result$, I&

handler = FreeFile
On Error GoTo open_error
 
' KK: this creates a file; should not;

Open file_to_read For Binary As #handler
' this statement has problems with file length about 90K:
 result = Space(LOF(handler))
 I = Len(result)
 
 If I = 0 Then
     read_f = ""
     Close #handler
     Exit Function
 Else
 
     On Error GoTo read_error
     Get #handler, 1, result
     Close #handler
     read_f = result
     Exit Function

 End If
 
read_error:
  e_up "when reading a file `" & _
  file_to_read & "` in `read_f` module"
open_error:
  e_up "when opening a file `" & _
  file_to_read & "` in `read_f` module"
End Function
 

Sub write_f(File_Name$, file_text$)
Dim handler%

handler = FreeFile
If file_text = "" Or File_Name = "" Then Exit Sub

On Error GoTo open_error
Open File_Name For Output Access Write Shared As handler
   
  On Error GoTo write_error
  Print #handler, file_text;    ' semicolumn is vital here ...
  Close #handler

Exit Sub

write_error:
  e_up "when writing a file `" & _
  File_Name & "` in `write_f` module"

open_error:
  e_up "when opening a file `" & _
  File_Name & "` in `write_f` module"
End Sub



Function write_file$(File_Name$, file_text$)
 Dim handler%

handler = FreeFile
On Error GoTo open_error
Open File_Name For Output Access Write Shared As handler
   
On Error GoTo write_error
Print #handler, file_text
Close #handler

write_file = "done" & vl & "  file `" & File_Name & "` " & "was successfully written on disk ... "
Exit Function

write_error:
 'write_file = "error" & vl & "error writing to a file " & Err.HelpContext & vbCrLf & Err.Description
 e_up "error writing to a file `" & File_Name & "`"
Exit Function
 
open_error:
 e_up "error when open a file `" & File_Name & "`"
 'write_file = "error" & vl & "error when open a file `" & file_name & "` " & vbCrLf & _
 '          Err.Description
End Function


'OUTPUT: combined ParentPath$ and FileNameEnd to make a full path;
'
'
Public Function path_ReSplit$(ParentPath$, FileNameEnd$)
    Dim CutSlash$
    Select Case Right(ParentPath, 1)
      Case "\": path_ReSplit = ParentPath & FileNameEnd
      Case "":   path_ReSplit = FileNameEnd
      Case Else:
           If FileNameEnd <> "" Then path_ReSplit = ParentPath & "\" & FileNameEnd
    End Select
End Function
'
'input: UmbrellaPath$, InputPath$
'
'output: SplitUmbrellaPath which is
'        the same as InputPath if UmbrellaPath is not a part of InputPath and
'        InputPath - UmbrellaPath in other case;
'
Public Function SplitUmbrellaPath$(UmbrellaPath$, InputPath$)
        Dim wi&
        wi = 0
        If UmbrellaPath <> "" And InputPath <> "" Then _
           wi = InStr(UCase(InputPath), UCase(UmbrellaPath) & "\")
        If wi > 0 Then
           'try to separate top path:
           SplitUmbrellaPath = Mid(InputPath, 2 + Len(UmbrellaPath))
        Else
           SplitUmbrellaPath = InputPath
        End If
End Function
'INPUT:  File Name to read
'OUTPUT: File Text  ( or empty if file is directory or empty )
'
'
'this creates many redundant subroutines:
'
'
Public Function IfFileExist_ReadIt$(File_Name$)

On Error GoTo he

IfFileExist_ReadIt = ""

If File_Name = "" Then Exit Function
If Dir(File_Name) = "" Then Exit Function

If (GetAttr(File_Name) And vbDirectory) = vbDirectory Then Exit Function
IfFileExist_ReadIt = read_f(File_Name)

Exit Function

he:
End Function
