Attribute VB_Name = "frmaux"
Option Explicit

Public Console_Text_Limit&
Public output_text_slice&
'EXCE free
'
' simple console display
' refreshed after Console_Text_Limit
' does not save to a file;
'      assumes that data is saved separately;
'
'
' input: s$ - source text
'        txtControl - text box
'
Sub Console(S$, txtControl As Object)
 Dim TextLength&, HalfLimit&, WFragmentLength&
 Dim FullLength&
 Dim c$, wi&

 With txtControl
  TextLength = Len(.Text)
  WFragmentLength = Len(S)
  If WFragmentLength = 0 Then Exit Sub
  
  FullLength = TextLength + WFragmentLength

  If WFragmentLength > Console_Text_Limit Or _
     FullLength > Console_Text_Limit Then
     HalfLimit = Console_Text_Limit / 2
     
     c = "Upper part of console has been cut," & ve & _
         "but all output is saved in file:" & ve & _
         co_MasterName & ve & _
         "independently on what is displayed on console." & ve & ve
         
     If WFragmentLength > Console_Text_Limit Then
        c = c & Right(S, HalfLimit)
     Else
        c = c & Right(.Text & S, HalfLimit)
     End If
     .Text = c
  ElseIf TextLength = 0 Then
     .Text = S
  Else
     c = Right(.Text, 1)
   
     'does this really avoids flicker?:
     .SelStart = TextLength - 1
     .SelLength = 1
     .SelText = c & S
     
  End If
  
  TextLength = Len(.Text)
  If TextLength > 0 Then
  
     'to avoid bad flicker, put cursor on the
     'beginning of string;
     wi = InStrRev(Left(.Text, TextLength - 1), vl) + 1
     .SelStart = wi - 1
  
  End If
 End With
End Sub

' frm specific lib
Sub msg_and_end(S$)
    MsgBox (S)
    End
End Sub


'DESC:  Puts form right in the center.
'INPUT: Form object.
'
'
Public Sub CenterForm(FO As Form)
Dim WLeft&
WLeft = (Screen.Width - FO.Width) / 2
If WLeft < 1 Then WLeft = 1

Dim WTop&
WTop = (Screen.Height - FO.Height) / 2
If WTop < 1 Then WTop = 1

FO.Left = WLeft
FO.Top = WTop
End Sub



