VERSION 5.00
Begin VB.Form frmSelectPath 
   BackColor       =   &H00C0C0C0&
   Caption         =   "select folder or file"
   ClientHeight    =   3915
   ClientLeft      =   9435
   ClientTop       =   795
   ClientWidth     =   6105
   Icon            =   "conc.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3915
   ScaleWidth      =   6105
   Begin VB.Frame Frame1 
      Height          =   735
      Left            =   120
      TabIndex        =   6
      Top             =   3120
      Width           =   5895
      Begin VB.CommandButton cmdEnd 
         Caption         =   "&apply"
         Height          =   375
         Left            =   2760
         TabIndex        =   8
         Top             =   240
         Width           =   3015
      End
      Begin VB.CommandButton cmdCancel 
         Caption         =   "&cancel"
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   240
         Width           =   2535
      End
   End
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "refresh"
      Height          =   255
      Left            =   5280
      TabIndex        =   4
      Top             =   2880
      Width           =   735
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   2535
   End
   Begin VB.FileListBox File1 
      Height          =   2625
      Left            =   2760
      TabIndex        =   2
      Top             =   120
      Width           =   3255
   End
   Begin VB.TextBox txtPattern 
      Height          =   285
      Left            =   1560
      TabIndex        =   1
      Text            =   "*.*"
      Top             =   2880
      Width           =   3615
   End
   Begin VB.DirListBox Dir1 
      Height          =   2340
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   2535
   End
   Begin VB.Label lblPattern 
      Alignment       =   2  'Center
      Caption         =   "file pattern:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   2880
      Width           =   1335
   End
End
Attribute VB_Name = "frmSelectPath"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit




Private m_PathSelected$
Private m_FileSelected$
Private m_GlobalPattern$
Private m_SelectionIsDone As Boolean
Private m_BlockPatternChange As Boolean


Property Get FileSelected$()
FileSelected = m_FileSelected
End Property


Property Get PathSelected$()
PathSelected = m_PathSelected
End Property



Private Sub cmdCancel_Click()
Unload Me
End Sub

Private Sub cmdEnd_Click()
    m_PathSelected = Dir1.Path
    m_FileSelected = File1.FileName
    m_SelectionIsDone = True
    Unload Me
End Sub
Property Get SelectionIsDone() As Boolean
SelectionIsDone = m_SelectionIsDone
End Property


Private Sub cmdRefresh_Click()
  If m_GlobalPattern = "" Then
     txtPattern = "*.*"
  Else
     txtPattern = m_GlobalPattern
  End If
End Sub

Private Sub Dir1_Change()
Dim wFullParentName$, WOwnName$

If m_BlockPatternChange Then Exit Sub
On Error GoTo he
wFullParentName = get_PathedParent(txtPattern.Text, WOwnName)
If Trim(txtPattern.Text) <> WOwnName Then
   txtPattern.Text = WOwnName
Else
   txtPattern_Change
End If

he: Exit Sub
End Sub


Private Sub Drive1_Change()
 Dir1.Path = Drive1.Drive
End Sub


Public Sub SetValues(FullNameP$, FilterPattern$)
Dim FullParentName$, WPath$
Dim WL&, ws$, WOwnName$
Dim FullName$

'===============================
'check for mistakes in
'  FullNameP:
On Error Resume Next
ws = Dir(FullNameP, vbDirectory)
If 0 < Err.Number Then
   'probably bad name:
   'start from harmless name
   FullName = App.Path
Else
   FullName = FullNameP
End If
'================================

On Error GoTo he
  
m_SelectionIsDone = False

FullParentName = get_PathedFixedParent(FullName, WOwnName)
If FilterPattern = "" Then
   m_GlobalPattern = WOwnName
Else
   m_GlobalPattern = FilterPattern
End If

'need?: ------------
'm_PathSelected = FullParentName
'm_FileSelected = WOwnName
'-------------------
    
If Dir(FullName, vbDirectory) <> "" Then
   If (GetAttr(FullName) And vbDirectory) = vbDirectory Then
             WPath = FullName        'no file; only folder
   Else
             WPath = FullParentName
             'not good:
             'manually select WOwnName in the list - easy.
   End If
Else
    'if dir does not exist, search for maximum existing parent dir path
    Do Until Dir(FullParentName, vbDirectory) <> ""
       DoEvents
       FullParentName = get_PathedFixedParent$(FullParentName, WOwnName)
    Loop
    WPath = FullParentName
 End If
 Drive1.Drive = Left(WPath, 1)
 Dir1.Path = WPath
 txtPattern.Text = FilterPattern
 
 Show 1
 'no \\machine_name\... for now
 Exit Sub
 
he:
  xMe = Err.Description
  xNo = Err.Number
  Resume xNext
xNext:
  On Error GoTo 0
  eUp "in frmSelectPaht.SetValues"
    
End Sub



Private Sub File1_DblClick()
  cmdEnd_Click
End Sub

Private Sub Form_Load()
m_BlockPatternChange = False
End Sub


Private Sub txtPattern_Change()

Dim wFullParentName$, WOwnName$
If m_BlockPatternChange Then Exit Sub
    
On Error GoTo he
              
wFullParentName = get_PathedParent$(txtPattern.Text, WOwnName)
If wFullParentName <> "" Then
   m_BlockPatternChange = True
   If Mid(wFullParentName, 2, 1) = ":" Then
      Drive1.Drive = Left(wFullParentName, 1) 'may causes dir1.path
      If Mid(wFullParentName, 3, 1) <> "\" Then
         wFullParentName = Replace(wFullParentName, ":", ":\")
      End If
      Dir1.Path = wFullParentName
   End If
   m_BlockPatternChange = False
Else
   WOwnName = Trim(txtPattern.Text)
End If
File1.Path = Dir1.Path

Select Case WOwnName
       Case "*": File1.Pattern = "*.*"
       Case "": File1.Pattern = "*.*"
       Case Else: File1.Pattern = WOwnName
End Select
              
he:  Exit Sub

End Sub




Private Sub txtPattern_DblClick()
  cmdEnd_Click
End Sub

Private Sub txtPattern_KeyPress(KeyAscii As Integer)
If KeyAscii = 13 Then
   If File1.ListCount = 1 Then
      File1.ListIndex = 0
   End If
End If
End Sub


