VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPrint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const Replacement$ = vbTab & vbTab & vbTab & ". "

Public MResultText$   'Master Result Text.
Private moDlg As CDialog
Private moPc As CProcedure
Private moTz As CTokenizer
Private moAc As Acto

'==============================================================================
'  To output
'------------------------------------------------------------------------------

Public DllForDesktop As Boolean    'Web or desk. True - Desktop.
                                   'Dets dll's mode and MsgBox particulary.

'Making it object can be slow:
Private ppout As Object 'Vb version.

'Vital: add reference to "Microsoft Active Server Pages [1.0] Object Library."
'Private Response_Web_Object As Response '   As Object
'Witout this reference:
Private Response_Web_Object As Object

Public BlockHTMLEncoding As Boolean

'------------------------------------------------------------------------------
'  To output
'==============================================================================


'Environment and switches:
Public output_text_to_console As Boolean

Private dummy&
Public Sub SetMoActo(ac As Acto)
Set moAc = ac
End Sub

Public Sub SetMoDialog(dlg As CDialog)
Set moDlg = dlg
End Sub

Public Sub add_ConvertedFragmentToResult(s$)
 If output_text_to_console Then
    If moDlg.deb Then OUTO_Console ve
    OUTO_Console s
    If moDlg.deb Then OUTO_Console ve
 End If
 MResultText = MResultText + s
End Sub


' OUTPUT CONSOLE STREAM
Public Sub OUTO_Console(s$)
If s = "" Then Exit Sub

'Response_Web_Object
If DllForDesktop Then
   If Not ppout Is Nothing Then
    'KK.FIX IT: perphaps slow:
    'but, need for protection from print
    'when obj.init:
    ppout.writes s      ' for vb
   End If
Else
   If Not Response_Web_Object Is Nothing Then
   
      If Not BlockHTMLEncoding Then
         Response_Web_Object.Write HTMLEncode(s, False)
      Else
         Response_Web_Object.Write s
      End If
      'ssmain.writes s     '
      'rp.Write s          ' for web
   End If
End If

End Sub


'DESC Should be in CPrint.
'
Public Sub Dialog_to_panel(print_queue As Boolean)
Dim ws$, wi&

ws = ve & "D# " & moDlg.DlgNm & "    NEST = "
ws = ws & GlobalNest_to_display & ve

If print_queue And moDlg.Ubound_g_que > 0 Then _
   ws = ws & "QUEUE: " & moDlg.GloblaQueue_for_display

prn_NSI "TOKEN:" & Token_for_display
prn_NSI "TYPE :" & moTz.eo_type

End Sub

Public Sub SetMoProcedure(pc As CProcedure)
Set moPc = pc
End Sub


Public Sub SetMoTokenizer(tz As CTokenizer)
Set moTz = tz
End Sub

Public Sub SetPrintObject(po As Variant)
Set ppout = po
End Sub

Public Sub SetResponseWebObject(rwo As Variant)
Set Response_Web_Object = rwo
End Sub

Public Function Token_for_display$()
  Token_for_display = TokenString_for_display(moTz.eo_token)
End Function

Public Sub print_CompiledSchema()
 Dim wi&
 PrintNL ve & "COMPILED SCHEMA:"
 For wi = 1 To moDlg.es_EvStatementsNumber
     moDlg.print_ES wi
 Next
 PrintNL "COMPILED SCHEMA END"
End Sub


Public Sub PrintS(s$)
    OUTO_Console s
End Sub


'do2 move to AHead?
'
Public Sub OUT_Raw_To_Web_Console(s$)
If Not Response_Web_Object Is Nothing Then
       Response_Web_Object.Write s
      'ssmain.writes s     '
      'rp.Write s          ' for web
   End If
End Sub


'microhelper:
Public Function GlobalNest_to_display$()
 GlobalNest_to_display = Replace(GetGlobalNest, vl, " ")
End Function

Public Sub prd_NL(s$)
    If moDlg.deb Then PrintL ve & s
End Sub

'OUTPUT Returns list of states in format:
'       [state \n][state \n] ...
'
'NOTE must be better that "co-named"
'     poor proc.
'     Satisfies list-standard
Public Function GetGlobalNest$()
Dim wi&, ws$
For wi = 1 To moDlg.dlgPs
    ws = ws & moTz.StateNameStr(moDlg.RunTimeNest(wi)) & vl
Next
GetGlobalNest = ws
End Function

Sub output_help()
Dim WBSyn$, WSep$
WBSyn$ = "[" & salph__ClusterSeparator & "true|false] now is "
WSep = salph__ClusterSeparator

PrintL ve & ve & "HELP. RUN-TIME AND COMPILE-TIME COMMANDS AND COMPILER CURRENT VALUES."
    
PrintL ""
PrintL aCP__HELP & " or " & aCP__HELP2 & "  - sets help; no parameters; "
     
     
    
    
    PrintL ""
    PrintL "Commands can have a parameter."
    PrintL """" & WSep & """ separates command and parameter."
    PrintL ""
    
    
     PrintL aCP__SUSPEND & WSep & moDlg.suspended
     PrintL aCP__DEBUG & WSep & moDlg.deb
     PrintL aCP__DDEBUG & WSep & moDlg.ddeb & "  - sets ""detailed debug"" and ""debug"";"
     PrintL aCP__PDEBUG & WSep & moPc.pdeb & "  - sets program debug;"
   
    
    
    PrintL aCP__SAVE_FILE_MODE & WSep & moAc.env_save_file_mode
    PrintL aCP__BLOCK_HTMLENCODING & WSep & BlockHTMLEncoding
    PrintL aCP__ClearGlobalQueue & WSep
    'PrintL aCP__EVENT_STATEMENT_MASK & WSep & env_event_statement_mask & " - not work yet"
    PrintL aCP__TOKENIZER_RECONIZES_QUOTED_STRINGS & WSep & moTz.env_recongnize_strings
        
    PrintL aCP__OUTPUT_CASE & WSep & moPc.env_output_case
        
    PrintL aCP__INDENT_BODY & " - sets indent; current value=" & _
           moPc.indent_body & "<END OF INDENT CONSTANT>"
    PrintL aCP__SEPARATORS_ARE_GLOBAL & WSep & moTz.env_separators_are_global
    PrintL aCP__SKIP_PROJECT & WSep & moAc.env_SKIP_PROJECT
    
    PrintL aCP__NATIVE_SEPARATORS & WSep & moTz.env_native_separators
    PrintL aCP__no_change_outside_result & WSep & moAc.env_no_change_outside_result
    PrintL aCP__RECOGNIZE_NUMBERS & WSep & moTz.env_recognize_numbers
    
    PrintL aCP__WORD_CASE_SENSETIVE & WSep & moDlg.env_word_case_sensetive
    PrintL aCP__AllowOrphanStates & WSep & moTz.env_AllowOrphanStates
           
    PrintL aCP__KEYWORD_CASE_SENSETIVE & WSep & moTz.env_keyword_case_sensetive
    PrintL aCP__MAKE_INDENT_AT_EACH_STATE & WSep & moPc.env_make_indent_at_each_state
    PrintL aCP__SEPARATOR_CASE_SENSETIVE & WSep & moTz.env_separator_case_sensetive
    PrintL aCP__each_char_is_separator & WSep & moTz.env_each_char_is_separator
    PrintL aCP__TZ_STRIP_QMARKS & WSep & moTz.tz_strip_qmarks
    PrintL aCP__TZ_CONV_STR & WSep & moTz.tz_conv_str
        
    PrintL aCP__TZ_WORD_CASE & WSep & moTz.tz_word_case
    PrintL aCP__TZ_SEPARATOR_CASE & WSep & moTz.tz_separator_case
    PrintL aCP__TZ_ID_CASE & WSep & moTz.tz_id_case
    PrintL aCP__TZ_KEYWORD_CASE & WSep & moTz.tz_keyword_case
    PrintL aCP__TZ_STRING_CASE & WSep & moTz.tz_string_case
        
    PrintL aCP__OUTPUT_TEXT_TO_CONSOLE & WSep & output_text_to_console
    
    PrintL ""
    PrintL "Input-only:"
    PrintL aCP__BASIC_ENVIRONMENT & WSep & " input your value: VBScript or Generic."
    PrintL aCP_TOKENS_CASE_SENSETIVE & " input your value: Yes or No; Yes recognizes case for words, separators, and keywords;"
    
    PrintL "END OF HELP"
    PrintL "==========="
    PrintL ""

End Sub
Public Sub prd_NSI(s$)
    If moDlg.deb Then prn_NSI s
End Sub

'DESC important proc which divides
'     debug output to two panels
'        Left for subject output
'        Right for debug output
'
'     print from the new line
'     with Shift and Indent:
'     no ve added at the end;
'
Public Sub prn_NSI(s$)

  prn_SI s, True
    
End Sub


'DESC Prints to second panel.
'
'
'
Public Sub prn_SI(s$, StartFromNewLine As Boolean)
    Dim IndentMade$, I%, ReplacementMade$, ws$
    
    IndentMade = ""
    For I = 1 To moDlg.dlgPs
        IndentMade = IndentMade & "  "
    Next
    ReplacementMade = Replacement & IndentMade
    
    If StartFromNewLine Then
       ws = "^r^n" & LossyHat(s)
    Else
       ws = LossyHat(s)
    End If
    
    'Attention: this is loose dislplay:
    '  1. it replaces combinations ^r^n which may "natively"
    '     exist in the text:
    '  2. Hat is lossy.
    
    PrintS Replace(ws, "^r^n", ve & ReplacementMade)

End Sub

 
 

'adds ve to both beginning and end of
'the string s;
Public Sub PrintNL(s$)
    PrintL ve & s
End Sub


'DESC escapes single text-breakers or first
'     character.
'
Public Function TokenString_for_display$(tok$)
Dim WToken$, wi&

WToken = Replace(tok, Chr(0), "\z")

Select Case tok
  Case ve: WToken = "\l"
  Case vl: WToken = "\n"
  Case vr: WToken = "\r"
  Case Else:
       Select Case Len(tok)
           Case 0
           Case Else
                wi = Asc(Left(tok, 1))
                If 32 > wi Then
                   WToken = "\" & Format(wi, "000") & Mid(tok, 2)
                Else
                   WToken = tok
                End If
       End Select
End Select
                   
TokenString_for_display = WToken

End Function


Public Sub prd_L(s$)
    If moDlg.deb Then PrintL s
End Sub

'
'adds ve to a string;
'
Public Sub PrintL(s$)
    OUTO_Console s & ve
End Sub



Private Sub Class_Initialize()
DllForDesktop = False
End Sub


Private Sub Class_Terminate()

Set moDlg = Nothing
Set moPc = Nothing
Set moTz = Nothing
Set moAc = Nothing

End Sub


