VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTokenizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Possibly only for Find Token:
'****************************************************************************
'         eo - "OUTSIDE" EVENT - EXTERNAL EVENT
'============================================================================
Public eo_token$                   ' Current eo_token.
Public eo_type$
'****************************************************************************



Private deb As Boolean

'============================================================================
' Part of scenario. Should not be in text parsers.
' do2 ReDim
Private StateName$(UboundStateName_M)    'Map idex -> Name
Public UboundStateName&                  'how many states really registered
'****************************************************************************



'Legend ..._psc - parse scenario

'parseSchema is not very close to CTokenizer, but it is still tightly close
'to MSourceText, so still stays with CTokenizer.
'Perhaps in future to separate ...

'SplitCluster is just a foreign wrapper which uses muPsn and MSourceText


'The procedures "rawparse_", raw...,
'wrap raw parsing and immediate actions
'   |<immedeate>
'In their structure, they repeat procedures
'   tks_

Private moDlg As CDialog
Private moPc As CProcedure
Private moTz As CTokenizer
Private moXc As CException
Private moPr As CPrint
Private moVr As CVariables
Private moFt As CFolderTree
Private moAc As Acto



'all tks-procedures are used in proc_InmmediateAction only;
'    therefore, their code is not optimized and
'    they are about to be obsolete;

Private CurrentSeparatorsArray$(10000)

Public CurrentSeparatorsArrayUbound&
Public CurrentSeparatorsList$

Public FormerTextPosition&

Public MSourceText$ 'Master source text.
Public muPsn&       'Position in Master source text.


'For FindToken:
Public tz_conv_str$


'Auxiliary:
Public rawparse_StashedFirstPosition&
Public gloEndOfTextIsAlreadyMet10Times&


'Switches:
Public tz_word_case$
Public tz_separator_case$
Public tz_id_case$
Public tz_keyword_case$
Public tz_string_case$
Public env_recongnize_strings As Boolean



Public env_p_keywords_enabled As Boolean     'Tz
Public env_p_recognize_vbtype_decl_chars As Boolean 'Tz
Public env_p_vbtype As String                       'Tz
Public env_separators_are_global As Boolean     'Tz
Public env_native_separators As Boolean
Public env_recognize_numbers As Boolean
Public env_keyword_case_sensetive As Boolean
Public env_separator_case_sensetive As Boolean
Public env_each_char_is_separator As Boolean
Public tz_strip_qmarks As Boolean

'Switches to parse scenario:
Public env_AllowOrphanStates As Boolean


'Switches of parser of macros:
'This flag is false for the first project's round
'     which is in schema-project and
'     automatically set to true after the
'     schema-project.
Public flagPermitBeginningOf As Boolean

'For exception
Private espot$
Private xMe$, xNo&
Public Sub SetDebug(db As Boolean)
deb = db
End Sub

Public Sub SetMoAc(ac As Acto)
Set moAc = ac
End Sub



Public Sub SetMoVariables(vr As CVariables)
Set moVr = vr
End Sub

Public Sub SetMoXception(xc As CException)
Set moXc = xc
End Sub

Public Sub SetMoPrint(pr As CPrint)
Set moPr = pr
End Sub

Public Function StateNameStr$(Ix&)
StateNameStr = StateName(Ix)
End Function

'RETURNS "" if none found
'        WChar is it is found
'OUTPUT  muPsn is inchanged if found.
'        muPsn = TextLen + 1 if not found.
'
Public Function tks_UntilChar$(WChar$)
Dim wi$
wi = InStr(muPsn, MSourceText, WChar$)
If wi = 0 Then
   wi = Len(MSourceText) + 1
   tks_UntilChar = ""
Else
   tks_UntilChar = WChar
   muPsn = wi
End If
End Function


'searches for the first solid char on line;
'
'RETURNS if eof  --> ""
'        comment --> vl, after going untill vl;
'        eol     --> vl
'        solid   --> solid
'
'OUTPUT  if eot  => muPsn = len + 1
'        otherwise, muPsn = char-muPsn
'
'NOTE    1) therfore, "" and vl are obvious flags after return;
'        2) does not need any soft char before word to
'           start the search and find the word;
'
Public Function tks_UntilSolidOnLine$()
Dim ws$
  

Do
  
  ws = Mid(MSourceText, muPsn, 1)
  tks_UntilSolidOnLine = ws
  Select Case ws
    Case salph__Comment:        'this will return vl, or if eot, then ""
                                tks_UntilSolidOnLine = tks_UntilChar(vl)
    Case " ", vbCr, vbTab:      GoTo ContinueSearch
    'Case vbLf:                 tks_ShowFirstSloidOnLine = vl
    'Case ""                    tks_ShowFirstSloidOnLine = ""  'eot is found
    Case Else:    'covers ""(eot), vl, or solid-word
  End Select
  Exit Function

ContinueSearch:
  muPsn = muPsn + 1
  DoEvents
Loop

End Function


'DESC    all soft characters, cr, lf are skipped
'        until solid found and returned;
'        muPsn is set on this solid;
'
'output: eof   --> ""
'        solid --> solid
'        muPsn = char-muPsn
'
'NOTE:   comments handled
'        search is not restricted "with" one line;
'        ("non-successfull" lines are skipped;)
'
Public Function tks_UntilSolid$()
Dim ws$

Do
 DoEvents
 ws = tks_UntilSolidOnLine
 If ws <> vbLf Then Exit Do
 muPsn = muPsn + 1
Loop

tks_UntilSolid = ws

End Function



'OUTPUT: returns WS-first char of solid word which was indented;
'        if not found (case eot, not indented solid), then ""
'        void lines (comments, empty) skipped;
'        search is not restricted in one line;
'
'output resume: eot or non-indented solid  --> ""
'               solid                      --> first char of solid
'               muPsn at the beginning of found fragment;
'
'
'
'INPUT:  beginning of the searching line or
'        vl on the previous line;
'
'
'
Public Function tks_UntilIndentedSolid$()
Dim ws$
  
tks_UntilIndentedSolid = ""      '
  
ContinueUntilNextNest: DoEvents

  ws = Mid(MSourceText, muPsn, 1)
  If ws = " " Or ws = vbTab Then GoTo CheckForWord


  '----------------------------------------
  ' skip void lines
  '----------------------------------------
  If ws = vl Then
    muPsn = muPsn + 1
    GoTo ContinueUntilNextNest
  ElseIf ws = salph__Comment Or ws = vr Then
    tks_UntilChar vl
    muPsn = muPsn + 1
    GoTo ContinueUntilNextNest
  End If
  '----------------------------------------
  

  'the case "" or non-indented solid is left which is branched here:
EndOfText:    tks_UntilIndentedSolid = ""
Exit Function
 
  
CheckForWord:
  
  muPsn = muPsn + 1
  ws = tks_UntilSolidOnLine
  If ws = "" Then GoTo EndOfText
  If ws = vl Then
     muPsn = muPsn + 1
     GoTo ContinueUntilNextNest
  End If
  'now, consider that solid word beginning is found
  tks_UntilIndentedSolid = ws

End Function


'
' UpToString:  this char is NOT attached to the found string
'            eo_type = e__IDENTIFICATOR
'            muPsn is set next to the found complex;
'
'
Public Sub FindToken(UpToString$, IgnoreDeclared As Boolean)

Dim I&, j&
Dim Slider&             'position at which separator is being searched;
Dim separator_length&, ws$, wi&
Dim Is_this_separator$, w_eo_token$
Dim WIs_this_separator$ 'for case manipulations;

Dim W_is_a_keyword As Boolean
Dim native_separator$
Dim w$
Dim WUpToFoundPosition&
Dim es_LastActivated&
Dim First_in_RecognizedFork&

Dim WEventPattern$
Dim WEventPatternLength&
Dim Weo_RecognizedIndex_flag&
Dim WACTIVATED&
Dim WSize&
Dim WEventPatternEscaped$
Dim ActivationIndex&

Dim WEndPos&
Dim SourceTextLength&

Dim eo_RawSeparator$            ' Next eo_token name - flag.

On Error GoTo he

If moDlg.flag_TEXT_STOPPED Then Exit Sub

SourceTextLength = Len(MSourceText)
'==============================================================================
'       DEBUGGING
'must never come out from this proc. with this value
espot = "TZ: POSITION: " & muPsn & " "
moPr.prd_NSI espot
'==============================================================================
   
'flush output values:
eo_token = ""
eo_type = ""
CurrentSeparatorsArrayUbound = -1      'no seps in the list;
CurrentSeparatorsList = vl             'no seps in the list;
Weo_RecognizedIndex_flag = 0

'this improvement may be is not valid:



'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
If muPsn > SourceTextLength Then

END_OF_FILE:     eo_type = e__EOT
    
    If deb Then moPr.prn_NSI "TZ: end of text found ... "
    If gloEndOfTextIsAlreadyMet10Times > 10 Then
      eo_token = _
           "End of text has been met 10 times, " & ve & _
           moXc.GetSituationDescription
      eo_type = e__EXC
      gloEndOfTextIsAlreadyMet10Times = 0
      Exit Sub
    End If
    gloEndOfTextIsAlreadyMet10Times = gloEndOfTextIsAlreadyMet10Times + 1
    Exit Sub
End If
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

'put this here, for eot doesnot damage its value:
FormerTextPosition = muPsn
  
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'IT IS BETTER TO MOVE THIS TO PROC WHICH "IS LIKE" ACTION:
If UpToString = "" Then GoTo STEPS_IN_SOURCE_VIA_NATIVE_SEPARATORS
'==========================================================================
WUpToFoundPosition = InStr(muPsn, MSourceText, UpToString)
     
If WUpToFoundPosition = 0 Then WUpToFoundPosition = SourceTextLength + 1
eo_token = Mid(MSourceText, muPsn, WUpToFoundPosition - muPsn)
'DOES NOT CHANGE A TYPE:
'eo_type = e__WORD
        
'muPsn will be next after found complex:
muPsn = WUpToFoundPosition
'make muPsn "well defined":
If muPsn > SourceTextLength + 1 Then muPsn = SourceTextLength + 1
GoTo ExitSub
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>






'///////////////////////////////////////////////////////////////////////////
STEPS_IN_SOURCE_VIA_NATIVE_SEPARATORS:       'this is only the loop to cut native seps.

'=======================================
'little improvement:
'all chars are tokens:
If env_each_char_is_separator Then
   eo_token = Mid(MSourceText, muPsn, 1)
   muPsn = muPsn + 1
   eo_type = e__SEPARATOR
   Select Case tz_separator_case
          Case "U": eo_token = UCase(eo_token)
          Case "L": eo_token = LCase(eo_token)
   End Select
   GoTo ExitSub
End If
'=======================================

native_separator = ""
separator_length = 0
eo_RawSeparator = ""
                                  
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
For Slider = muPsn To SourceTextLength   'SEARCH FOR SEPARATOR
'==========================================================================
    DoEvents
    '================================================================================
    If env_recongnize_strings Then
    '--------------------------------------------------------------------------------
       'kk.later: not good; make var. for mid ...
       If Mid(MSourceText, Slider, 1) = """" Then
          'string, but where?
          If Slider > muPsn Then
             'this means that following quoted string cuts a word;
             'go take this word;
             GoTo KISFOUND
          Else
             'string must be extracted and made word.str-external-event
             'position must be advanced
             eo_token = CutQuotedString(MSourceText, muPsn, WEndPos, True, tz_strip_qmarks, _
                                        tz_conv_str, tz_string_case)
             eo_type = e__STRING
             muPsn = WEndPos
             If deb Then moPr.prn_NSI "TZ: STRING=`" & eo_token & "`"
             'FINALLY CLOSE TO THE EXIT:
             GoTo ExitSub
          End If
       End If
    End If
    '================================================================================
    
          
    
    If IgnoreDeclared Then GoTo DeclaredSearchSkipped
    If CurrentSeparatorsArrayUbound <> -1 Then GoTo ScroolViaBuiltSeps
    
    'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    '      A      AAA  AAAAA  A  A     A   AA   AAAAA  AAAA
    '    A   A   A       A    A   A   A   A  A    A    A
    '    AAAAA   A       A    A    A A    AAAA    A    AAA
    '    A   A    AAA    A    A     A     A  A    A    AAAA
    '============================================================================
        DoEvents
        CurrentSeparatorsArrayUbound = 0
        First_in_RecognizedFork = 0
        es_LastActivated = -1

For ActivationIndex = 1 To moDlg.es_EvStatementsNumber
  
  'token must be present, to activate a separator:
  If moDlg.esType(ActivationIndex) = e__ANY Then
     'very "raw": because nest may not fit current nest:
     If First_in_RecognizedFork = 0 Then First_in_RecognizedFork = ActivationIndex
  End If
  If moDlg.esToken(ActivationIndex) = "" Then GoTo Sorry
  
  
  If moDlg.esType(ActivationIndex) = e__SEPARATOR Then
     If moDlg.esGlobal_type(ActivationIndex) = e__global_type_GLOBAL Then
        GoTo Activated
     ElseIf moDlg.esGlobal_type(ActivationIndex) = e__global_type_LOCAL Then
        GoTo TestOwnNests
     Else
        If env_separators_are_global Then GoTo Activated
        GoTo TestOwnNests
     End If
  End If
  GoTo Sorry
  
TestOwnNests:
  WSize = moDlg.esNest_size(ActivationIndex)
  
  If moDlg.dlgPs < WSize Then GoTo Sorry
     'e_MANY_STATES
  For j = 1 To WSize
         If moDlg.esNest(ActivationIndex, j) <> moDlg.RunTimeNest(moDlg.dlgPs - WSize + j) _
           And moDlg.esNest(ActivationIndex, j) <> si__ Then
           'si__ = any state;
           '===================================
           moDlg.esActivated(ActivationIndex) = False
           '===================================
           GoTo Sorry
         End If
     DoEvents
  Next
     '===================================
Activated:

  'fffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff
  '"fix from escaping":
  '--------------------------------------------------
        ' substitute variables and ... if any:
        If moDlg.esNO_ESCAPES(ActivationIndex) Then
                WEventPattern = moDlg.esToken(ActivationIndex)
        Else
                WEventPattern = moVr.var_SubstituteShortCuts(moDlg.esToken(ActivationIndex))
        End If
        '--------------------------------------------------
        
        'CASECASECASECASECASECASECASECASECASECASE'CASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASE
        If Not env_separator_case_sensetive Then WEventPattern = LCase(WEventPattern)   'for "definity" use a low case
            
        'w is an e-pattern=sep.-pattern now;
        WEventPatternLength = Len(WEventPattern)
        
        'WEventPatternLength=0 may happen if substituted string is empty
        If WEventPatternLength = 0 Then GoTo Sorry
  'fffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff
  WEventPatternEscaped = Replace(Replace(WEventPattern, "^", "^^"), vl, "^\") & vl
  '"string below" means that this separator is already in the list:
  If InStr(CurrentSeparatorsList, vl & WEventPatternEscaped) > 0 Then GoTo Sorry
  'time to make a test, and if test is not passed, store this sep:
  'TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
         eo_RawSeparator = Mid(MSourceText, Slider, WEventPatternLength)
        If env_separator_case_sensetive Then
           WIs_this_separator = eo_RawSeparator
        Else
           'CASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASESECASECASE
           WIs_this_separator = LCase(eo_RawSeparator)
        End If
             
        'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
        If WIs_this_separator = WEventPattern Then   '   SEPARATOR RECOGNIZED
        '================================================================================
                If deb Then moPr.prn_NSI "TZ: SEP=`" & Left(eo_RawSeparator, 10) _
                    & " ...`(" & Asc(Left(eo_RawSeparator, 1)) & " ...); event =" & ActivationIndex
                separator_length = WEventPatternLength
                Weo_RecognizedIndex_flag = CurrentSeparatorsArrayUbound + 1
                GoTo KISFOUND
        End If
        'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
  
  'TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
  CurrentSeparatorsArrayUbound = CurrentSeparatorsArrayUbound& + 1
  CurrentSeparatorsList = CurrentSeparatorsList & WEventPatternEscaped & vl
  CurrentSeparatorsArray(CurrentSeparatorsArrayUbound) = WEventPattern
  
  'vvvvvvvvvvv very good for debug: vvvvvvvvvvvvvvvvvv
  'do2 make them
  'If ddeb Then moPr.prd_NSI "Activated IN THE LIST:"
  'If ddeb Then modlg.print_ES ActivationIndex
  'vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
  
Sorry: Next
GoTo SkippedLoopViaBuiltSeps
'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
ScroolViaBuiltSeps:
    'MsgBox CurrentSeparatorsList
    '================================================================================
    For WACTIVATED = 1 To CurrentSeparatorsArrayUbound
    'LOOP VIA ACTIVATED SEPARATORS
    '--------------------------------------------------------------------------------
        
        WEventPattern = CurrentSeparatorsArray(WACTIVATED)
        WEventPatternLength = Len(WEventPattern)
        
        'BEGINNING OF DUPLICATED CODE:
        eo_RawSeparator = Mid(MSourceText, Slider, WEventPatternLength)
        If env_separator_case_sensetive Then
           WIs_this_separator = eo_RawSeparator
        Else
           'CASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASECASESECASECASE
           WIs_this_separator = LCase(eo_RawSeparator)
        End If
             
        'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
        If WIs_this_separator = WEventPattern Then   '   SEPARATOR RECOGNIZED
        '================================================================================
                If deb Then moPr.prn_NSI "TZ: SEP=`" & Left(eo_RawSeparator, 10) _
                    & " ...`(" & Asc(Left(eo_RawSeparator, 1)) & " ...)"
                separator_length = WEventPatternLength
                Weo_RecognizedIndex_flag = WACTIVATED
                GoTo KISFOUND
        End If
        'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
        'END IF DUPLICATED CODE;
    '---------------------------------------------------------------------------
    Next
    '================================================================================
SkippedLoopViaBuiltSeps:
DeclaredSearchSkipped:
     
     '=====================================================================================================
     If env_native_separators Then
     '------------------------------------------------------------------------------------------------------
          If Asc(Mid(MSourceText, Slider, 1)) < 33 Then
              separator_length = 1
              'slow, but sure:
              native_separator = Mid(MSourceText, Slider, 1)
              If deb Then moPr.prn_NSI "TZ: NSEP=`" & native_separator & _
                 "`=" & Asc(native_separator)
              GoTo KISFOUND
          End If
     '------------------------------------------------------------------------------------------------------
     End If     ' end search for native separators if declared separator is not found
     '===========================================================================================================


Next        ' ef SEARCH FOR SEPARATOR
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    
    
    
    
    


'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
KISFOUND:
If Slider > muPsn Then    'WORD IS IN THE THIRS POSITION
'=================================================================================
       eo_token = Mid(MSourceText, muPsn, Slider - muPsn)
       If deb Then moPr.prn_NSI "TZ: WORD=`" & eo_token & "`"
       
       
       'KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
       '    EXTRACTING KEYWORDS
       '====================================================================================================================
       If env_keyword_case_sensetive Then w_eo_token = eo_token Else w_eo_token = LCase(eo_token)  'handle chars case;
       W_is_a_keyword = False:       I = 1:       eo_type = e__WORD 'temp.
       '--------------------------------------------------------------------------------------------------------------------
       If Not env_p_keywords_enabled Then GoTo ExitThisDo
       Do
         'kk.later:  'If moDlg.esType(I) = e__KEYWORD And moDlg.esActivated(I) Then               ' look for true keywords
         If moDlg.esType(I) = e__KEYWORD Then
             'must be e__word above;
             'if deb then mopr.prn_NSI " seach for keywords; event =`" & es_pattern(i) & "`"
             
             '-----------------------------------------------------------------------
             'before compare pattern and target, substitute values into the pattern
             If moDlg.esNO_ESCAPES(I) Then
                WEventPattern = moDlg.esToken(I)
             Else
                WEventPattern = moVr.var_SubstituteShortCuts(moDlg.esToken(I))
             End If
             '-----------------------------------------------------------------------
             
             'handle the characters case:
             If env_keyword_case_sensetive Then WEventPattern = moDlg.esToken(I) Else WEventPattern = LCase(moDlg.esToken(I))

             
             '-----------------------------------------------------------------------
             '  COMPARING WEventPattern AND target:
             If w_eo_token = WEventPattern Then
                'ASSUME THAT EVENT HAS BEEN RECOGNIZED:
                eo_type = e__KEYWORD
                'eo_RecognizedIndex = I
                If deb Then moPr.prn_NSI "TZ: KEYWORD=`" & w_eo_token & "`"
                GoTo ExitThisDo
             End If
             '-----------------------------------------------------------------------
             
         End If
         I = I + 1
         DoEvents
       Loop While I <= moDlg.es_EvStatementsNumber
       'KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK

'........................................................
ExitThisDo:       ' handle types and the rest ...
'........................................................
       If eo_type = e__WORD Then
       
          If env_p_recognize_vbtype_decl_chars Then
             If Len(eo_token) < 2 Then
                env_p_vbtype = ""
             Else
                Select Case Right(eo_token, 1)
                Case "$", "@", "%", "&", "!", "#"
                     env_p_vbtype = Right(eo_token, 1)
                     eo_token = Left(eo_token, Len(eo_token) - 1)
                Case Else
                     env_p_vbtype = ""
                End Select
             End If
          End If
       
          'insert number recognition:
          If env_recognize_numbers Then
             wi = Asc(Left(eo_token, 1))
             '------------------------------------------------------
             '  this is a place where type of word may be splitted:
             If wi < 58 And wi > 47 Then
                eo_type = e__NUMBER
             Else
                eo_type = e__IDENTIFICATOR
                Select Case tz_id_case
                  Case "U": eo_token = UCase(eo_token)
                  Case "L": eo_token = LCase(eo_token)
                End Select
             End If
          Else
             'no, we do not recognize numbers: everything is word:
             'so, "case the word":
             Select Case tz_word_case
                  Case "U": eo_token = UCase(eo_token)
                  Case "L": eo_token = LCase(eo_token)
             End Select
          End If
       ElseIf eo_type = e__KEYWORD Then
          Select Case tz_keyword_case
                  Case "U": eo_token = UCase(eo_token)
                  Case "L": eo_token = LCase(eo_token)
          End Select
       End If
       muPsn = Slider
       GoTo ExitSub
'..................................................................
'      ef types and the rest
'..................................................................


'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Else    '  SEPARATOR IS IN THE FIRST POSITION: k=muPsn
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       muPsn = Slider + separator_length
       
       '==========================================================================
       'kk.later: how can this be: = ""?
       'If eo_RawSeparator <> "" Then           ' DECLARED FOUND. EXIT.
       '--------------------------------------------------------------------------
       If Weo_RecognizedIndex_flag > 0 Then
          'this will insure that separator is found; not the native; not elegant;
          eo_type = e__SEPARATOR
          Select Case tz_separator_case
                 Case "U": eo_token = UCase(eo_RawSeparator)
                 Case "L": eo_token = LCase(eo_RawSeparator)
                 Case Else: eo_token = eo_RawSeparator
          End Select
          'eo_type = moDlg.esType(Weo_RecognizedIndex_flag)
          'disable this:
          'eo_RecognizedIndex = Weo_RecognizedIndex_flag
          GoTo ExitSub
       End If
       '==========================================================================
       'if program is here, this means
       'that native separator is in the
       'first position, and it must be skipped ...
       If muPsn > SourceTextLength Then GoTo END_OF_FILE
       'this is only the place where top loop spinnings:
       GoTo STEPS_IN_SOURCE_VIA_NATIVE_SEPARATORS
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
End If      'END HANDLING SEPARATOR IN THE FIRST POSITION
'/////////////////////////////////////////////////////////////////////////////////
e_stop "Unexpected exit from loop in Tokenizer."

ExitSub:
gloEndOfTextIsAlreadyMet10Times = 0
Exit Sub
'===================================================

'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
he:
xNo = Err.Number
xMe = Err.Description
Resume xNext
xNext: On Error GoTo 0
       'eUp "In proc. FindToken."
       moXc.ReportAndClassifyException xNo, xMe, espot, "Find Token"
'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
End Sub




'Part of scenario. Not parto of text parsers.
'
Sub init_NamesArrayForReservedStates()

StateName(si__) = s__
StateName(si__Many) = s__Many
StateName(si__Root) = s__Root

StateName(si__Schema) = s__Schema
StateName(si__Statement) = s__Statement

StateName(si__Non_Specified) = s__Non_Specified
UboundStateName = si_TotalDefaults

End Sub

'returns 0 if state index is not found
'
Private Function mmFindStateIndex_psc&(s$)
Dim K&
K = 0
For K = 1 To UboundStateName
    If StateName(K) = s Then
        mmFindStateIndex_psc = K
        Exit Function
    End If
    DoEvents
Next
End Function



Public Sub parse_Schema_psc()

Dim WInternalState_AbsOrNot$

Dim WNestText$
Dim WStateInNest$
Dim WNestLength&

Dim WEventPattern$
Dim Wsequence&(30)                       ' stores states when parsing
Dim WStateIndex&
Dim WSavedNextTokenPosition&
Dim WArray, Wstatus, TokensNumber&, End_position&

Dim WStatesArray
Dim WStatesShift&()
Dim WhereToStart&

Dim AInteraction$
'kk.later: make this common saved position for exception handling:
Dim WExceptionActionPosition&

Dim wi&, WII&, WJ&, ws$, WSS$

Dim WEventName$
Dim WStreamControl$
Dim TokensNumberEffective&

Dim gqd As CommonQueue

On Error GoTo he

'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
            espot = "C O M P I L I N G   S C H E M A"
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
moPr.prd_NL "position in the text: " & muPsn & " "









'NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN
'NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN
' NEST PARSING
'=======================================================================
BeginNestParsing:
  If moDlg.flag_TEXT_STOPPED Then GoTo ParsingSchemaLoopEnd
  
  espot = "Parsing nest. Position=" & muPsn
  
  Dim loN&
  'If rawparse_Solid(ws) Then GoTo ParsingSchemaLoopEnd
  loN = raw_S
  Select Case loN
  Case 9:   GoTo ParsingSchemaLoopEnd
  Case 13:  moDlg.flag_TEXT_STOPPED = True
            GoTo ParsingSchemaLoopEnd
  End Select

  ws = Chr(loN)
  
'NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN
'NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN

'====================================================
'now start to parse a real nest cluster:
WArray = ParseQuotedCluster(muPsn, _
         MSourceText, salph__StateSeparator, _
         alph__TextStartedSignal, alph__EscInText, _
         alph__Variable, _
         Wstatus, TokensNumber)

If TokensNumber < 1 Then e_stop "incorrect nest-pattern"
If TokensNumber > Ubound_es_nest_M Then _
    e_stop "error in schema: states' nest is greater than " & _
           Ubound_es_nest_M

For WNestLength = 1 To TokensNumber
    DoEvents
    WStateInNest = WArray(WNestLength)
    
    If WStateInNest = s__Any Then
       WStateInNest = s__
       'filter -a to - for backward compatibility;
    End If
   
    '--------------------------------
    'looking between existing states:
    WStateIndex = 0
    For wi = 1 To UboundStateName
        If StateName(wi) = WStateInNest Then
           WStateIndex = wi
           GoTo ContinueInTheNest
        End If
    Next
ContinueInTheNest:
    '--------------------------------
    
    '------------------------------------------------------------
    If WStateIndex = 0 Then 'accomulating states from the nest:
       UboundStateName = UboundStateName + 1
       WStateIndex = UboundStateName
       StateName(UboundStateName) = WStateInNest
       moPr.prd_NL "registering state:=" & StateName(UboundStateName)
    End If
    
    'save nest which is found:
    Wsequence(WNestLength) = WStateIndex    ' ef accomulating
    '------------------------------------------------------------
    
'nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
Next        '  ef NEST PARSING
WNestLength = WNestLength - 1
If WNestLength < 1 Then e_stop "unexpectably empty nest"
'NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN
   
     
     
     
     
     





'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
                'E  V  E  N  T    P A T T E R N
'==========================================================================
ExpectEvStatement:
     If moDlg.watchTerminateText Then GoTo ParsingSchemaLoopEnd
espot = "Parsing Event-Pattern. Position=" & muPsn
If rawparse_IndentedSolid(ws) Then GoTo ParsingSchemaLoopEnd
If "" = ws Then GoTo BeginNestParsing

'==========================================================================
mmIdxi_es_psc
moDlg.esPost_beginning(moDlg.es_EvStatementsNumber) = 0   'start up flag
WArray = SplitCluster(Wstatus, TokensNumber)

'--------------------------------------------------------------------------
'       FILL OUT NEST PATTERN
'kk.improve: better make reference on Nest object ""rather"" copy values:
moDlg.esNest_size(moDlg.es_EvStatementsNumber) = WNestLength
For wi = 1 To WNestLength
    moDlg.esNest(moDlg.es_EvStatementsNumber, wi) = Wsequence(wi)
Next
'---------------------------------------------------------------------------------------

moDlg.esType(moDlg.es_EvStatementsNumber) = e__SEPARATOR  'default

Select Case TokensNumber
  Case 0:     e_stop "Unexpectably empty token-event-pattern."
  Case 1:     'ReDim Preserve WArray(2)
              WArray(2) = "": TokensNumber = 2
  Case 2, 3:
  Case Else:  e_stop "Event pattern cannot have more than 3 parts."
End Select

If WArray(2) = "" Then
   If WArray(1) = "" Then
      WArray(2) = e__ANY
   Else
      WArray(2) = e__SEPARATOR
   End If
ElseIf IsNumeric(WArray(2)) Then
   
   'case .10, .22
   WArray(1) = take_asc(CStr(WArray(2)))
   WArray(2) = e__SEPARATOR
   
End If

'-------- finally transfer values to the event: ----------------------------------------------
moDlg.esToken(moDlg.es_EvStatementsNumber) = WArray(1)
moDlg.esType(moDlg.es_EvStatementsNumber) = WArray(2)
If TokensNumber >= 3 Then
   moDlg.esGlobal_type(moDlg.es_EvStatementsNumber) = WArray(3)
Else
   moDlg.esGlobal_type(moDlg.es_EvStatementsNumber) = e__global_type_UNSPECIFIED
End If

If Wstatus(1) = c__Variabled Then
   moDlg.esNO_ESCAPES(moDlg.es_EvStatementsNumber) = False
Else
   moDlg.esNO_ESCAPES(moDlg.es_EvStatementsNumber) = True
End If
'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE





















'QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
'
'      Q  U  E  U  E        P  A  R  S  I  N  G
'
'
'QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
Expect_Queue_On_This_Line:   ' ACTIONS QUEUE

On Error GoTo ExceptonInActionParsing:
espot = "Parsing actions from position " & muPsn
WExceptionActionPosition = muPsn
If moDlg.watchTerminateText Then GoTo QueueCompleted
'===================================================================================================================================

If rawparse_SolidOnLine(AInteraction) Then GoTo ParsingSchemaLoopEnd
'   find solid pair: Escaper & ActionCluster;
'-----------------------------------------------------------------------------------------------------------------------------------
If AInteraction = vbLf Or AInteraction = "" Then
   'QUEUE COMPLETED: vl => eol; "" => eof
    muPsn = muPsn + 1
    GoTo QueueCompleted 'which may be empty;
End If
'===================================================================================================================================






'-----------------------------------------------------------------------------------------------------------------------------------
SolidAInteractionFound:          ' solid AInteraction is found; negotiate it;
Select Case AInteraction
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     Case salph__StateEsc, salph__ShiftUp, salph__ShiftDown:
          muPsn = muPsn + 1: GoTo ParseState
     Case salph__Event, salph__Late_Event, _
          salph__Action, salph__Immidiate: muPsn = muPsn + 1
     Case Else
          
          'nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
          'GENERALIZATIONS:
          '================================================================
          wi = 0 'flag
          ws = Mid(MSourceText, muPsn, 1)
          WSS = Mid(MSourceText, muPsn, 2)
                    
          If ws <> "." Then GoTo NormallActions
          If WSS <> ".." Then GoTo Gen2
          'possibly "..", chech for it
          ws = Mid(MSourceText, muPsn + 2, 1)
          Select Case ws
                 Case " ", vbTab, vbCr, vbLf, ""
                      '"bingo=.."
                      WArray(1) = ""    'no matter
                      WArray(2) = e__SKIP_TOKEN
                      TokensNumber = 2  'no matter
                      AInteraction = salph__Late_Event
                      muPsn = muPsn + 2
                      GoTo CLUSTER_ALREADY_PARSED
          End Select
          GoTo NormallActions

Gen2:     'still can be "."; check for it:
          ws = Mid(MSourceText, muPsn + 1, 1)
          Select Case ws
                 Case " ", vbTab, vbCr, vbLf, ""
                      '"bingo=."
                      WArray(1) = ""    'no matter
                      WArray(2) = e__SKIP_RECOGNITION
                      TokensNumber = 2  'no matter
                      AInteraction = salph__Late_Event
                      muPsn = muPsn + 1   'hope to comply with SplitCluster
                      GoTo CLUSTER_ALREADY_PARSED
          End Select
          'nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
NormallActions:  AInteraction = salph__Action
          'NOTE: NO muPsn+1:
          'This is a part of generalization when : is omitted.
'nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
End Select
'------------------------------------------------------------------------------------------------------------------------------------

'------------------------------------------------------------------------------------------------------------------------------------
'      FIND CLUSTER ITSELF
WArray = SplitCluster(Wstatus, TokensNumber)

CLUSTER_ALREADY_PARSED:
If TokensNumber > 0 Then GoTo CLUSTER_IS_NOT_EMPTY
'------------------------------------------------------------------------------------------------------------------------------------
GoTo AssemblyQueueElement 'goto events and actions empty cluster generalization;









'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
ParseState:
'====================================================================================================================================
'     FIND STATE-QUEUE-NEST-CLUSTER: >4,-s,-r,state  or =-s,-r,moo  or <b,s,d


WStatesArray = ParseQuotedCluster( _
               muPsn, _
               MSourceText, _
               salph__StateSeparator, alph__TextStartedSignal, _
               alph__EscInText, alph__Variable, _
               Wstatus, TokensNumber)
'ReDim WArray(1)  'no type for state is still available;
'ReDim Wstatus(1) 'this value is not used;
WhereToStart = 1
'this may modify the first state in the local nest:
WInternalState_AbsOrNot = salph__StateEsc 'by default, it is relative;

'Analyse what is after >, =, or <
Select Case TokensNumber
 Case 0:    'nothing after >,<,=
        TokensNumberEffective = 1
        'dim always >=4; no need to redim:
        'ReDim WStatesArray(TokensNumberEffective)
        ReDim WStatesShift(TokensNumberEffective)
        WStatesArray(1) = s__
        Select Case AInteraction
           Case salph__ShiftUp:    WStatesShift(TokensNumberEffective) = 1
           Case salph__ShiftDown:  WStatesShift(TokensNumberEffective) = -1
           Case Else:
                
                'ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
                'GENERALIZE SINGLE = AS start from the global nest buttom:
                ReDim WStatesShift(1)
                WStatesShift(1) = 1
                WInternalState_AbsOrNot = ialph__AbsStateEsc
                WStatesArray(1) = s__
                'ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg

           GoTo NestIsReady
        End Select
 Case Else
      '=====================================================================================
      ' there are some fragments in local nest cluster:
      ' >4    or  =t   or <4,c
      ' don't change number of fragments to exclude the shift-fragment:
      ' instead, change index-where-to-start later if need;
      ' so, do exactly:
      TokensNumberEffective = TokensNumber
      ReDim WStatesShift(TokensNumberEffective)
      
      '--------------------------------------------------------------------------------------
      'set default shifts for the case of =moo,moo,moo:
      For wi = 1 To TokensNumberEffective
            WStatesShift(wi) = 1
      Next
      WStatesShift(1) = 0                'by default, the first state replaces current state;
      '--------------------------------------------------------------------------------------
      
      If Not FirstIsDigit(CStr(WStatesArray(1))) Then
      
          '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          'no first-frgment-shift: only one correction according <, or >
          'case: >s,d,...   =b,c;    made it artificially
          Select Case AInteraction
           Case salph__ShiftUp
                WStatesShift(1) = 1
           Case salph__ShiftDown
                WStatesShift(1) = -1
           'case else     'which is =moo,moo,moo already has all its properties:
                          'correct tokens number which is from parsing cluster;
                          'correct first shift which is 0
                          'first state type which is relative;
          End Select
          '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
          
      Else
          'nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
          If TokensNumber <> 1 Then
             '  digit is present and clasters are too like:  <3,state
             '  exclude the first claster-fragment form the nest:
             WhereToStart = 2
          End If
          
          '----------------------------------------------------------------------
          Select Case AInteraction
            Case salph__ShiftUp
                WStatesShift(WhereToStart) = CLng(WStatesArray(1))
            Case salph__ShiftDown
                WStatesShift(WhereToStart) = -CLng(WStatesArray(1))
            Case Else
                '=====================================================================
                ' Digit after = like =1 or =0 tells about absolute positioning
                ' in global nest;
                '---------------------------------------------------------------------
                WInternalState_AbsOrNot = ialph__AbsStateEsc
                WStatesShift(WhereToStart) = CLng(WStatesArray(1))
                'protect absolute state: not below 1;
                If WStatesShift(WhereToStart) < 1 Then WStatesShift(WhereToStart) = 1
                '=====================================================================
          End Select
          If TokensNumber = 1 Then
             WStatesArray(1) = s__      ' <3   - make first state neutral;
                                        ' cannot do this earlier, because
                                        'WStatesAray(1) is in use;
          End If
          
          'nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
      End If
End Select
   
   
'===================================================================================================================================
NestIsReady:  'Nest to be added always starts from WhereToStart and ends at TokensNumberEffective.
'-----------------------------------------------------------------------------------------------------------------------------------
For wi = WhereToStart To TokensNumberEffective
            'store "all the states":
            WArray(1) = WStatesArray(wi)
            'wstatus has no matter, but to comply to printing rules, set it:
            Wstatus(1) = c__PlainText
            '1=tokens number:
            ws = salph__StateEsc
            If WhereToStart = wi Then ws = WInternalState_AbsOrNot
            moDlg.MoveToQueueDepository ws, WArray, Wstatus, 1, WStatesShift(wi)
Next
GoTo Expect_Queue_On_This_Line
'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS








AssemblyQueueElement:
'000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
'   CLUSTER IS EMPTY: SINGLE CHAR AInteraction GENERALIZATIONS: single: +  :  >  <  -
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
If AInteraction = salph__Action Then

   '============================================================
   If rawparse_SolidOnLine(ws) Then GoTo ParsingSchemaLoopEnd
   '   find solid pair: Escaper & ActionCluster;
   '------------------------------------------------------------
   If ws = vbLf Or AInteraction = "" Then
       
      '-----------------------------------------
      '  :   -  true continue found
      '         do continue on the next string
      '-----------------------------------------
      If rawparse_IndentedSolid(AInteraction) Then GoTo _
         ParsingSchemaLoopEnd
      If AInteraction = "" Then GoTo BeginNestParsing
      'exceptional queue loop entrance:
      GoTo SolidAInteractionFound
    
   Else
      '-----------------------------------------------
      '  :  -   means .n in this case:
      '         cluster after : found;
      '         this is not a continue;
      '-----------------------------------------------
      WArray(1) = ""
      WArray(2) = aR__NONE
      TokensNumber = 2
      'attempt to continue:
      GoTo GENARALIZING_ACTION
   End If
   '===============================================================
       
ElseIf AInteraction = salph__Event Then         'case +  ---> deferring current event;
       WArray(1) = ""
       WArray(2) = e__DEFERRED
       TokensNumber = 2
ElseIf AInteraction = salph__Late_Event Then    'case *  ---> taking current event from tokenizer;
       WArray(1) = ""
       WArray(2) = e__ANY
       TokensNumber = 2
'ElseIf AInteraction = salph__Immidiate Then
'       'single | case: make it |end_schema
'       WArray(1) = aC__END_SCHEMA
'       TokensNumber = 1
End If
'000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000



CLUSTER_IS_NOT_EMPTY:
'GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
'   GENERALIZATIONS NUMBER 2
'====================================================================================================================================
If AInteraction <> salph__Action Then GoTo ActionGeneralizationSkipped

'====================================================================================================================================
GENARALIZING_ACTION:
'------------------------------------------------------------------------------------------------------------------------------------
If TokensNumber = 1 Then
      '------------------------------------------------------------------------------------------------------------------------------
      'first fragment is
      'moo      or
      '>        or
      ')        or
      '""       ...
      'this is a very basic action which is a simple
      'output of an unqouted or quouted text:
      '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      'ReDim Preserve WArray(2)
      WArray(2) = aR__OUTPUT_TOKEN
      TokensNumber = 2
      '------------------------------------------------------------------------------------------------------------------------------
ElseIf TokensNumber = 2 Then
      If WArray(2) = "" Then
         If Wstatus(1) <> c__PlainText Or WArray(1) <> "" Then
            ' <first-level-significant-text>.    "dot exists" then this is "the same if no dot";
            'if first level significant text:
            WArray(2) = aR__OUTPUT_TOKEN
         Else
            '  only dot exists:   .   ,then action is no-action:
            WArray(2) = aR__NONE
         End If
      'else no need to specify because WArray(2) already fixed;
      End If
ElseIf TokensNumber > 2 Then
     If TokensNumber = 4 And _
          WArray(1) = "" And WArray(2) = "" And WArray(3) = "" And _
          Wstatus(1) = c__PlainText And Wstatus(2) = c__PlainText And Wstatus(3) = c__PlainText Then
          '     ...MyVar   --->  token = MyVar
          WArray(3) = "="
          'to handle case:    MyVar = token, use    .=MyVar
          WArray(2) = aR__PROGRAM
     ElseIf WArray(1) = "" And WArray(2) = "" And _
          Wstatus(1) = c__PlainText And Wstatus(2) = c__PlainText Then
          'this is a program like     ..<something>
          WArray(2) = aR__PROGRAM
     End If
End If
'----------------------------------------------------------------------------
'perpare streams:
If TokensNumber = 1 Then GoTo StreamsPreparationSkipped
'----------------------------------------------------------------------------
WStreamControl = Left(WArray(2), 1)
Select Case WStreamControl
    Case aR__STREAM_ON, aR__STREAM_OFF, aR__STREAM_ON_AND_EMPTY
         ws = Mid(WArray(2), 2)
         If TokensNumber < 3 Then
            TokensNumber = 3
         End If
         WArray(3) = ws
         WArray(2) = WStreamControl
End Select

StreamsPreparationSkipped:
ActionGeneralizationSkipped:
'====================================================================================================================================

'====================================================================================================================================
'   EVENTS GENERALIZATION 2
'------------------------------------------------------------------------------------------------------------------------------------
If AInteraction = salph__Event Or AInteraction = salph__Late_Event Then
   If TokensNumber = 2 Then
      If WArray(1) = "" And IsNumeric(WArray(2)) Then
          'Abbr. .10  .22 in event-queue:
          WArray(1) = take_asc(CStr(WArray(2)))
          WArray(2) = e__SEPARATOR
      ElseIf WArray(2) = "" Then
          WArray(2) = e__SEPARATOR
      End If
   ElseIf TokensNumber = 1 Then
      WArray(2) = e__SEPARATOR
      TokensNumber = 2
   End If
End If
'====================================================================================================================================
'  ef GENERALIZATIONS NUMBER 2
'GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG


'DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
'   WORKING WITH DEPOSITORY
    moDlg.MoveToQueueDepository AInteraction, WArray, Wstatus, TokensNumber, 0
GoTo Expect_Queue_On_This_Line
'DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD



QueueCompleted: On Error GoTo he
                If deb Then moDlg.print_ES moDlg.es_EvStatementsNumber
                GoTo ExpectEvStatement
'QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP=====
'QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP==QUEUE==LOOP=====

'LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL
ParsingSchemaLoopEnd: On Error GoTo he
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW






'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
'W              I N D E X    P O S T   S T A T E S
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
If moDlg.es_EvStatementsNumber < 1 Then GoTo EndIndexing
moPr.prd_NL "==========================" & ve & _
       "    indexing states" & ve & _
       "=========================="
moPr.prd_L "events quantity=" & moDlg.es_EvStatementsNumber
moPr.prd_L "states quantity=" & UboundStateName
   
'=====================================================================
For WJ = 1 To moDlg.es_EvStatementsNumber  'CYCLE VIA EXISTING EVENTS
'=====================================================================
     'bug If moac.flag_PROJECTS_STOPPED Then Exit For
     If moDlg.esPost_beginning(WJ) = 0 Then GoTo NextEvent
     moPr.prd_L "EVENT " & moDlg.esToken(WJ) & salph__ClusterSeparator & moDlg.esType(WJ)
     
     'do2:
     'If ddeb Then
     '   moPr.prd_L " :" & _
     '   moDlg.esPost_beginning(WJ) & "::::" & moDlg.esPost_end(WJ) & ": "
     'end if
     
     
     
     
     For wi = moDlg.esPost_beginning(WJ) To moDlg.esPost_end(WJ)
       
       With gqd
       moDlg.GlobQueueDepository_Get wi, _
                                     .Interaction, _
                                     .First, _
                                     .Second, _
                                     .Third, _
                                     .Fourth, _
                                     .Numberr, _
                                     .StateShift, _
                                     .FirstStatus, _
                                     .FourthStatus
                                      
                                     
       If salph__StateEsc = .Interaction Or ialph__AbsStateEsc = .Interaction Then
          .Numberr = mmFindStateIndex_psc(.First)          ' slow; do better
          
          'do2
          'If ddeb Then moPr.prd_L "state=" & .First & " index:" & .Numberr
          
          If .Numberr = 0 Then
              
              If env_AllowOrphanStates Then
                 UboundStateName = UboundStateName + 1
                 If UboundStateName_M < UboundStateName Then
                    moPr.PrintL "Too many states. More than " & _
                    UboundStateName_M & ". Terminating Schema Parser."
                                     'redefine poor state:
                    .First = s__Non_Specified
                    .Numberr = si__Non_Specified

                    moAc.flag_PROJECTS_STOPPED = True
                    moDlg.flag_TEXT_STOPPED = True
      
                 Else
                    StateName(UboundStateName) = .First
                    moPr.PrintL "Registering state:=" & StateName(UboundStateName)
                    .Numberr = UboundStateName
                 End If
              Else
              
                 moPr.PrintL "WARNING: in EVENT #" & WJ & " " & moDlg.esToken(WJ) & salph__ClusterSeparator & moDlg.esType(WJ)
                 moPr.PrintL "Queue " & (wi - moDlg.esPost_beginning(WJ) + 1) & "(th) element" & ve & _
                 .First & ve & _
                 ",which is state, does not have own explicit events ... " & ve & _
                 "Replacing it with non-specified event " & s__Non_Specified & ve
                 
                 'redefine poor state:
                 .First = s__Non_Specified
                 .Numberr = si__Non_Specified
              
              End If
               
          End If
       End If
       
          moDlg.GlobQueueDepository_Let wi, _
                                     .Interaction, _
                                     .First, _
                                     .Second, _
                                     .Third, _
                                     .Fourth, _
                                     .Numberr, _
                                     .StateShift, _
                                     .FirstStatus, _
                                     .FourthStatus
       
       
       
       
       End With
       DoEvents
     Next
     
'=====================================================================
NextEvent:  DoEvents
            If moAc.flag_PROJECTS_STOPPED = True Then GoTo EndIndexing
Next    'CYCLE VIA EXISTING EVENTS
'=====================================================================
EndIndexing:         'E N D    I N D E X I N G
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW


'---------------------------------------------------------------------
'   prepare schema to finish
'---------------------------------------------------------------------
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'this automatically drops "parsing schema" state
'only if nest = *,-schema and * is not empty:
'------------------------------------------------------------------------------
If moDlg.dlgPs > 1 Then
   If moDlg.RunTimeNest(moDlg.dlgPs) = si__Schema Then moDlg.dlgPs = moDlg.dlgPs - 1
End If
moVr.var_BeforeRunTimeCreatedVarPosition = moVr.UboundVarValues
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
If deb Then moPr.prd_NL "Position in the text: " & muPsn
    

'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
Exit Sub 'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE


'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
'  this is a general exception.
'==================================================================================================
he:
xNo = Err.Number
xMe = Err.Description
Resume xNext
   
xNext: On Error GoTo ExceptionInException

moXc.ReportAndClassifyException xNo, xMe, espot, "parse_Schema_psc"

GoTo ExceptionInException
Exit Sub
'==================================================================================================



'==================================================================================================
ExceptonInActionParsing:  'may be "overhead"
   xNo = Err.Number
   xMe = Err.Description
   Resume xNext2


xNext2: On Error GoTo ExceptionInException
    
    '---------------------------------------------------------------------
    'PREPARE PARSED NEST TO PRINT:
    '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    WNestLength = moDlg.esNest_size(moDlg.es_EvStatementsNumber)
    xMe = xMe & ve & "PARSED NEST: "
    For wi = 1 To WNestLength
        xMe = xMe & StateName(moDlg.esNest(moDlg.es_EvStatementsNumber, wi)) & ","
    Next
    '---------------------------------------------------------------------
    xMe = xMe & ve & "E v e n t -pattern:" & _
          moDlg.esToken(moDlg.es_EvStatementsNumber) & _
          salph__ClusterSeparator & moDlg.esType(moDlg.es_EvStatementsNumber) & ve
    xMe = xMe & "A p p r o x i m a t e positon in Schema: " & _
          WExceptionActionPosition & ve

    moXc.ReportAndClassifyException xNo, xMe, espot, "parse_Schema_psc"
    '=====================================================================

'=========================================================================
ExceptionInException:
    'no reports, sorry ...
    moAc.flag_PROJECTS_STOPPED = True
    moDlg.flag_TEXT_STOPPED = True
    Exit Sub  '<-- to avoid logical error
'=========================================================================
'   END OF EXCEPTION HANDLER
'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
End Sub



Private Sub mmIdxi_es_psc()
    moDlg.es_EvStatementsNumber = moDlg.es_EvStatementsNumber + 1
    If moDlg.es_EvStatementsNumber >= Ubound_es_M Then _
    e_stop "attempted to go out of event array limit " & Ubound_es_M
End Sub

'this is a wrapper of ParseQuotedCluster made for moAc.parse_Schema_psc
'
Public Function SplitCluster(TokenStatus, TokensNumber&)
SplitCluster = ParseQuotedCluster( _
               muPsn, _
               MSourceText, _
               salph__ClusterSeparator, alph__TextStartedSignal, _
               alph__EscInText, alph__Variable, _
               TokenStatus, TokensNumber&)
End Function

'DESC    Solid On Line
'INPUT   Start form position muPsn
'OUTPUT  RETURNS
'           13  if eof,           muPsn = FileLen + 1
'           10  if vl reached     muPsn = muPsn + 1
'           X   X<>13,10,9,32     muPsn = pos(X)
'           9   stop commanded    muPsn - undefinded 'do1a fix, remove?
'
Public Function raw_SL&()

Dim s$

Again:

DoEvents

s = Mid(MSourceText, muPsn, 1)

Select Case s
Case salph__Immidiate

     'muPsn will be muPsn+1 in this proc to skip "|"
     Select Case raw_RunMacro
     Case 0:     GoTo Again
                 'Apparently muPsn will be already advanced as muPsn = muPsn + 1
     Case 1:     raw_SL = 13 'eot
                 Exit Function
     Case 2:     raw_SL = 9  'stop
                 Exit Function
     End Select
     
      
Case " ", vbCr, vbTab
     muPsn = muPsn + 1
     GoTo Again
      
      
Case salph__Comment
     'This will return vl, or if eot, then ""
     'muPsn = pos(vl)
     Select Case tks_UntilChar(vl)
     Case "":    raw_SL = 13 'eot
     Case Else:  muPsn = muPsn + 1
                 raw_SL = 10
     End Select


Case vbLf
     raw_SL = 10
     muPsn = muPsn + 1


Case ""
     raw_SL = 13 'eot
     muPsn = Len(MSourceText) + 1

Case Else
     raw_SL = Asc(s)

End Select


End Function
'DESC    all soft characters, cr, lf are skipped
'        until solid found and returned;
'        muPsn is set on this solid;
'
'OUTPUT  eof   --> ""
'        solid --> solid
'        muPsn = char-muPsn
'
'RETURN  Alwyas false. 'do1a bug.
'
'NOTE:   comments handled
'        search is not restricted "with" one line;
'        ("non-successfull" lines are skipped;)
'
Public Function rawparse_Solid$(retchar$)

Dim n&

Do
 
 'DoEvents mandatory in raw_SL
 
 n = raw_SL
 Select Case n
 Case 9:    'Not used or causes bugs.
            retchar = ""
            rawparse_Solid = True
            Exit Do
 Case 10:   'retchar = vbLf
            'muPsn = muPsn - 1
 Case 13:   retchar = ""
            Exit Do
 Case Else: retchar = Chr(n)
            Exit Do
 End Select
 
Loop


'do1a
'Real bug candidtate:
'Was and is:
rawparse_Solid = False


End Function


'INPUT  muPsn must be set on
'       Immediate action character position "|".
'
'RETURN True if stops commanded or
'       if Tokens exhausted == apparently eot.
'
'
Public Function rawparse_ImmediateAction_DELETE() As Boolean

Dim WResultedStatus2$
Dim WSecondParameter$, WCommand$
Dim WArray, Wstatus, TokensNumber&
Dim W_QE_Index&
Dim ws$
Dim StashedFirstPosition&

rawparse_ImmediateAction_DELETE = False '=continue work
rawparse_StashedFirstPosition = muPsn

'Skip the "|" and ...
muPsn = muPsn + 1
'... begin to parse cluster:
WArray = SplitCluster(Wstatus, TokensNumber)

If TokensNumber = 0 Then
    'Single | case :: syntax shortcut :: make it |end_schema
    If deb Then moDlg.print_ES moDlg.es_EvStatementsNumber
    
    'If moDlg.dlgPs = 1 And si__Root Then
    'initiate beginning of text pretending
    'that bof, bot happened naturally:
    If Not moDlg.flag_TEXT_STOPPED Then
       If moDlg.dlgPs > 1 Then
         If moDlg.RunTimeNest(moDlg.dlgPs) = si__Schema Then
            'for nest: *,-schema
            '          action "|" will fire
            '             .bot
            '             .bof (if inside the folder)
            '             .bop
            '          and allow
            '             .eof
            '             .eop
            moDlg.proc_PushEvent_Modify moFt.p_extension, e__BOT
            If "" <> moFt.local_ppath Then moDlg.proc_PushEvent_Modify moVr.var_Get("p_parent"), "bof"
            moDlg.proc_PushEvent_Modify moFt.p_file, "bop"
            flagPermitBeginningOf = True
         End If
       End If
    End If
    rawparse_ImmediateAction_DELETE = True
    Exit Function
End If

espot = "Parsing immediate action: " & WArray(1)
     
Select Case WArray(1)
    Case aC__BEGIN_PROGRAM ' this is not an immediate action, but
                           ' "the collecting of action-program";
         'Public Const aC__BEGIN_PROGRAM$ = "program"
          
        
        '-------------------------------------------------------------
ContinueActionProgramParsing:       ' COLLECTING ACTION-PROGRAM
        If moDlg.watchTerminateText Then
           rawparse_ImmediateAction_DELETE = True
           Exit Function
        End If
        '-------------------------------------------------------------
         
        If tks_UntilSolid = "" Then _
           e_stop "Unexpectable action-program end."
        'WExceptionActionPosition = muPsn
        WArray = SplitCluster(Wstatus, TokensNumber)
                 
         'may redundant:
         If TokensNumber < 1 Then e_stop "Unexpectable empty action-statement"
                  
         espot = "Parsing command" & WArray(1) & " in program block. "
         
         'Public Const aC__END_PROGRAM$ = "end_program"
         If WArray(1) = aC__END_PROGRAM Then GoTo ReturnFromimmediate
         'This is the place to parse clean action-program statements:
            
         'do1b Very ineffective:
         'W_QE_Index = UBound(GlobQueueDepository) + 1
         W_QE_Index = moDlg.GlobQueueDepository_Ubound_Redim1
         
         If moDlg.esPost_beginning(moDlg.es_EvStatementsNumber) = 0 Then
            moDlg.esPost_beginning(moDlg.es_EvStatementsNumber) = W_QE_Index
         End If
         moDlg.esPost_end(moDlg.es_EvStatementsNumber) = W_QE_Index
         
         'do1b Very ineffective:
         'ReDim Preserve GlobQueueDepository(W_QE_Index)
          
         Dim gqd As CommonQueue
            
         With gqd 'GlobQueueDepository(W_QE_Index)
        
         .Interaction = salph__Action

         .First = ""
         .FirstStatus = c__PlainText
         .Second = aR__PROGRAM
         .Third = WArray(1)
         If TokensNumber > 1 Then
               .Fourth = WArray(2)
               .FourthStatus = Wstatus(2)
         Else
               .Fourth = ""
               .FourthStatus = c__PlainText
         End If
         
         moDlg.GlobQueueDepository_Let W_QE_Index, _
                                     .Interaction, _
                                     .First, _
                                     .Second, _
                                     .Third, _
                                     .Fourth, _
                                     .Numberr, _
                                     .StateShift, _
                                     .FirstStatus, _
                                     .FourthStatus
                                      

         End With
         '-------------------------------------------------------------
         GoTo ContinueActionProgramParsing  'ef parsing clean program;
         '-------------------------------------------------------------
     
   Case Else
     
        'this is the core of immediate action:
        '     the place where immediate action is executed:
     
         If c__Variabled = Wstatus(1) Then
            ws = WArray(1)
            WCommand = moVr.var_SubstituteShortCuts(ws)
            'WResultedStatus = c__QuotedText
         Else
            WCommand = WArray(1)
            'WResultedStatus = Wstatus(1)
         End If
         
         If UBound(WArray) > 1 Then
            WSecondParameter = CStr(WArray(2))
            WResultedStatus2 = CStr(Wstatus(2))
            If WResultedStatus2 = c__Variabled Then
               WSecondParameter = moVr.var_SubstituteShortCuts(WSecondParameter)
               WResultedStatus2 = c__QuotedText
            End If
         Else
            WResultedStatus2 = c__PlainText
            WSecondParameter = ""
         End If
         
         If Not moPc.proc_Program( _
                WCommand, WSecondParameter, WResultedStatus2) Then
            moPc.proc_Command WCommand, WSecondParameter, WResultedStatus2
         End If
         
CommandCompleted:
End Select

ReturnFromimmediate:

If moDlg.flag_TEXT_STOPPED Then _
   rawparse_ImmediateAction_DELETE = True

End Function


'DESC
'OUTPUT retchar "" - end of file returns false (or true in |"
'       vl         - end of line  returns false
'       " ", vbCr, vbTab are never returned
'       other char - if other char met (is a "solid" char) returns false
'
'NOTE comments on line starting with ' handled and vl or "" returned
'
'do1a check that tks_UntilChar works properly
'
'
Public Function rawparse_SolidOnLine(retchar$) As Boolean

Dim n&

rawparse_SolidOnLine = False
n = raw_SL
Select Case n
Case 9:  'Not used or causes bugs.
         retchar = ""
         rawparse_SolidOnLine = True
Case 10: retchar = vl
         muPsn = muPsn - 1
Case 13: retchar = ""
Case Else: retchar = Chr(n)
End Select

Exit Function









'======= removed =============
'======= removed =============
'======= removed =============
'======= removed =============
'======= removed =============
'======= removed =============
'======= removed =============

'Dim ws$
'
'rawparse_SolidOnLine = True'
'
'Do
'
'GetCharAgain:
'
'  'Perhaps redundant because schemas are too short:
'  DoEvents
'
'  '---------------------------------------
'  ' Dive into macros: ...
'  '- - - - - - - - - - - - - - - - - - - -
'  ws = Mid(MSourceText, muPsn, 1)
'  If salph__Immidiate = ws Then
'     'muPsn will be muPsn+1 in this proc to skip "|"
'     If rawparse_ImmediateAction Then
'        'Stops commande or eot
'        Exit Function
'     End If
'     'Apparently muPsn will be already advanced as muPsn = muPsn + 1
'     'after parsing all this clusters.
'     GoTo GetCharAgain
'  End If
'  '---------------------------------------
'
'  retchar = ws
'  Select Case ws
'    Case salph__Comment:        'This will return vl, or if eot, then ""
'                                retchar = tks_UntilChar(vl)
'                                'muPsn = muPsn(vl)
'    Case " ", vbCr, vbTab:      GoTo ContinueSearch
'    'Case vbLf:                 tks_ShowFirstSloidOnLine = vl
'    'Case ""                    tks_ShowFirstSloidOnLine = ""  'eot is found
'    Case Else:                  'covers ""(eot), vl, or solid-word
'  End Select
'
'  'the second exit from the function:
'  rawparse_SolidOnLine = False
'  Exit Function'
'
'ContinueSearch:
'  muPsn = muPsn + 1'
'
'Loop
'======= removed =============
'======= removed =============
'======= removed =============
'======= removed =============
'======= removed =============
'======= removed =============
'======= removed =============







End Function


'DESC    returns WS-first char of solid word which was indented;
'        if not found (case eot, not indented solid), then ""
'        void lines (comments, empty) skipped;
'        search is not restricted in one line;
'
'INPUT   beginning of the searching line or
'        vl on the previous line;
'
'OUTPUT  retchar =
'               eot or non-indented solid  --> ""
'               solid                      --> first char of solid
'               " ", vbTab, vbCr are never output.
'        muPsn     = at the beginning of found fragment;
'
'
Public Function rawparse_IndentedSolid(retchar$) As Boolean

Dim ws$
  
  
rawparse_IndentedSolid = True
  
  
  
  
ContinueUntilNextNest: DoEvents

  ws = Mid(MSourceText, muPsn, 1)
  If salph__Immidiate = ws Then
     
     Select Case raw_RunMacro
     Case 1:     'eot
                 Exit Function
     Case 2:     'stop
                 Exit Function
     End Select
     GoTo ContinueUntilNextNest
  
  End If
    
  If ws = " " Or ws = vbTab Then GoTo CheckForWord

  '----------------------------------------
  ' skip void lines
  '----------------------------------------
  If ws = vl Then
    muPsn = muPsn + 1
    GoTo ContinueUntilNextNest
  ElseIf ws = salph__Comment Or ws = vr Then
    tks_UntilChar vl
    muPsn = muPsn + 1
    GoTo ContinueUntilNextNest
  End If
  '----------------------------------------
  

'The case "" or non-indented solid is left which is branched here:
EndOfText:   retchar = ""
             rawparse_IndentedSolid = False

Exit Function
 
  
  
  
  
  
CheckForWord:
  
  muPsn = muPsn + 1
  'If rawparse_SolidOnLine(ws) Then Exit Function
  Dim n&
  n = raw_SL
  Select Case n
  Case 10:   GoTo ContinueUntilNextNest
  Case 13:   GoTo EndOfText
  Case 9:    'Not used or causes bugs.
             'stops
             Exit Function
  Case Else: retchar = Chr(n)
             rawparse_IndentedSolid = False
  End Select
       
End Function
'DESC   Runs only one macro. No program of macros
'       Additionally, can collect program .... end_program section.
'
'INPUT  muPsn must be set on
'       Immediate action character position "|".
'
'RETURN 0 if normal end
'       1 if end of text
'       2 if Stops commanded
'OUTPUT muPsn should be to the next after parsed cluster.
'
Public Function raw_RunMacro&()

Dim WResultedStatus2$
Dim WSecondParameter$, WCommand$
Dim WArray, Wstatus, TokensNumber&
Dim W_QE_Index&
Dim ws$
Dim StashedFirstPosition&


rawparse_StashedFirstPosition = muPsn

'Skip the "|" and ...
muPsn = muPsn + 1
'... begin to parse cluster:
WArray = SplitCluster(Wstatus, TokensNumber)



'------------------------------------
'  Eot
'- - - - - - - - - - - - - - - - - -
If TokensNumber = 0 Then
    'Single | case :: syntax shortcut :: make it |end_schema
    If deb Then moDlg.print_ES moDlg.es_EvStatementsNumber
    
    'If moDlg.dlgPs = 1 And si__Root Then
    'initiate beginning of text pretending
    'that bof, bot happened naturally:
    If moDlg.flag_TEXT_STOPPED Then
       raw_RunMacro = 2
    Else
       raw_RunMacro = 1
       If moDlg.dlgPs > 1 Then
         If moDlg.RunTimeNest(moDlg.dlgPs) = si__Schema Then
            'for nest: *,-schema
            '          action "|" will fire
            '             .bot
            '             .bof (if inside the folder)
            '             .bop
            '          and allow
            '             .eof
            '             .eop
            moDlg.proc_PushEvent_Modify moFt.p_extension, e__BOT
            If "" <> moFt.local_ppath Then
               moDlg.proc_PushEvent_Modify moVr.var_Get("p_parent"), "bof"
            End If
            moDlg.proc_PushEvent_Modify moFt.p_file, "bop"
            flagPermitBeginningOf = True
         End If
       End If
    End If
    Exit Function
End If
'- - - - - - - - - - - - - - - - - -
'  Eot
'------------------------------------





espot = "Parsing immediate action: " & WArray(1)
     
Select Case WArray(1)

    'Public Const aC__BEGIN_PROGRAM$ = "program"
    Case aC__BEGIN_PROGRAM ' this is not an immediate action, but
                           ' "the collecting of action-program";
          
        
        '-------------------------------------------------------------
ContinueActionProgramParsing:       ' COLLECTING ACTION-PROGRAM
        If moDlg.watchTerminateText Then
           raw_RunMacro = 2
           Exit Function
        End If
        '-------------------------------------------------------------
         
        If tks_UntilSolid = "" Then
           e_stop "Unexpectable action-program end."
        End If
        'WExceptionActionPosition = muPsn
        WArray = SplitCluster(Wstatus, TokensNumber)
                 
         'may redundant:
         If TokensNumber < 1 Then e_stop "Unexpectable empty action-statement"
                  
         espot = "Parsing command" & WArray(1) & " in program block. "
         
         'Public Const aC__END_PROGRAM$ = "end_program"
         If WArray(1) = aC__END_PROGRAM Then GoTo ReturnFromimmediate
         'This is the place to parse clean action-program statements:
            
            
         'do1b Very ineffective:
         'W_QE_Index = UBound(GlobQueueDepository) + 1
         W_QE_Index = moDlg.GlobQueueDepository_Ubound_Redim1
 
         If moDlg.esPost_beginning(moDlg.es_EvStatementsNumber) = 0 Then _
            moDlg.esPost_beginning(moDlg.es_EvStatementsNumber) = W_QE_Index
         moDlg.esPost_end(moDlg.es_EvStatementsNumber) = W_QE_Index
         
         Dim gqd As CommonQueue
            
         With gqd 'GlobQueueDepository(W_QE_Index)
        
         .Interaction = salph__Action

         .First = ""
         .FirstStatus = c__PlainText
         .Second = aR__PROGRAM
         .Third = WArray(1)
         If TokensNumber > 1 Then
               .Fourth = WArray(2)
               .FourthStatus = Wstatus(2)
         Else
               .Fourth = ""
               .FourthStatus = c__PlainText
         End If
         
         moDlg.GlobQueueDepository_Let W_QE_Index, _
                                     .Interaction, _
                                     .First, _
                                     .Second, _
                                     .Third, _
                                     .Fourth, _
                                     .Numberr, _
                                     .StateShift, _
                                     .FirstStatus, _
                                     .FourthStatus
                                      


         
         End With
         '-------------------------------------------------------------
         GoTo ContinueActionProgramParsing  'ef parsing clean program;
         '-------------------------------------------------------------
     
   Case Else
     
        'this is the core of immediate action:
        '     the place where immediate action is executed:
     
         If c__Variabled = Wstatus(1) Then
            ws = WArray(1)
            WCommand = moVr.var_SubstituteShortCuts(ws)
            'WResultedStatus = c__QuotedText
         Else
            WCommand = WArray(1)
            'WResultedStatus = Wstatus(1)
         End If
         
         If UBound(WArray) > 1 Then
            WSecondParameter = CStr(WArray(2))
            WResultedStatus2 = CStr(Wstatus(2))
            If WResultedStatus2 = c__Variabled Then
               WSecondParameter = moVr.var_SubstituteShortCuts(WSecondParameter)
               WResultedStatus2 = c__QuotedText
            End If
         Else
            WResultedStatus2 = c__PlainText
            WSecondParameter = ""
         End If
         
         If Not moPc.proc_Program( _
                WCommand, WSecondParameter, WResultedStatus2) Then
            moPc.proc_Command WCommand, WSecondParameter, WResultedStatus2
         End If
         
CommandCompleted:
End Select


ReturnFromimmediate:
If moDlg.flag_TEXT_STOPPED Then raw_RunMacro = 2


End Function
'DESC    Finds first solid in the raws of lines.
'OUTPUT  Apparently muPsn = muPsn of thi solid.
'
'
Public Function raw_S&()

Dim n&

Do
 
 'DoEvents mandatory in raw_SL
 n = raw_SL
 Select Case n
 Case 9:    'stops
            raw_S = n
            Exit Function
 Case 10:   'eol
 Case 13:   'eot
            raw_S = n
            Exit Function
 Case Else: raw_S = n
            Exit Function
 End Select
 
Loop


End Function

Public Sub SetMoProcedure(pc As CProcedure)
Set moPc = pc
End Sub

Public Sub SetMoFolderTree(ft As CFolderTree)
Set moFt = ft
End Sub

Public Sub SetMoDialog(dlg As CDialog)
Set moDlg = dlg
End Sub




Private Sub Class_Initialize()

deb = False
init_NamesArrayForReservedStates

End Sub


Private Sub Class_Terminate()

Set moDlg = Nothing
Set moPc = Nothing
Set moTz = Nothing
Set moXc = Nothing
Set moPr = Nothing
Set moVr = Nothing
Set moFt = Nothing
Set moAc = Nothing

End Sub


