Attribute VB_Name = "UParseString"
Option Explicit

Public Const alph__VariableEscapeLimitor = " "
Public Const VariableLimitor1 = " "
Public Const VariableLimitor2 = vbCr
Public Const VariableLimitor3 = vbLf
Public Const VariableLimitor4 = vbTab
Public Const VariableLImitor5 = """"

'YELD yes
'
'DESC extracts double-quoted string
'     "string" from input text S.
'
'     unscapes early-bound shortcuts and
'     preserves late bound shortcuts
'               with setting late flag.
'     Reescapes variables $var ---> \$var
'
'INPU 6 first parameters in the list.
'
'OUTP
'   end_position - last position which was used to build output string;
'   f.e. can be an length of file is source was used upto the end;
'
'
'NOTE
'
'  NOT RECOMMENDED TO USE s = SoftEscape( .. s .. )
'
'  DOES:
'
'  escapes .r .n .221 .002 .t .s if e_char = .
'  *********the rest is preserved:  *********
'  .. --> .. .x --> x .~ --> .~ ...
'  e_char may be different
'  text_escaper usually is " which terminates the text
'  however, putting it after main_escaper like \" results in \" --> "
'
'
Function SoftEscape( _
    start_position&, _
    s$, _
    e_char$, _
    variable_escaper$, _
    text_escaper$, _
    End_position&, _
    flag_substitute_variable_later As Boolean)

    
Dim L&, I&, I1&
Dim wi&, ws$
Dim WControlChar$
Dim w_current_char$
Dim ResultString$
Dim WVariableLimitorPosition&
Dim flag_esc_esc_found As Boolean
Dim WVarNameLimitor$
Dim FinalParsingPosition&
    
flag_substitute_variable_later = False
            
SoftEscape = ""
ResultString = ""
        
L = Len(s)
End_position = L
    
'protectors:
If start_position < 1 Then Exit Function
If L < start_position Then Exit Function
   
flag_esc_esc_found = False
I = start_position
'=========================================================
Do While I <= L        'MAIN LOOP
'=========================================================

w_current_char = Mid(s, I, 1)
If e_char = w_current_char Then GoTo EscapeSequence

If w_current_char = text_escaper Then
   'check for "" - case
   If I < L Then
      If Mid(s, I + 1, 1) = text_escaper Then
         'This If means that "" is found:
         ResultString = ResultString & w_current_char
         I = I + 2
         'skip "" and ...
         GoTo ContinueMainLoop
      End If
   End If
   'stop parsing:
   'return End_position equal to
   'closing double-quotes character position:
   End_position = I
   GoTo EndOfFunction
End If
       
            
If w_current_char = variable_escaper Then
            
   '...$variable... encountered
          
   '================================
   ' HANDLING NAME OF VARIABLE
   '--------------------------------
            
   'after parsing $variable<variable_terminator>,
   '      this contruct is converted to
   '              \$variable<space><variable_terminator>
   '                   if <variable_terminator> is not <space>
   '              to \$variable<space>
   '                   if <variable_terminator> is <space>
   '<variable_terminator> is  " ", CR, LF, TAB, ", end-of-line
   
   'in any case add main terminator " " _
   '   (alph__VariableEscapeLimitor)
   'terminates the end of variable name:
   
   'end-of-line terminator means:
   'if variable name is not terminated,
   'then extend its name up to the end of string:
            
   WVarNameLimitor = alph__VariableEscapeLimitor
            
   I1 = InStr(I, s, VariableLimitor1) 'chr(32)
   If I1 = 0 Then
      'in variable is not terminated by " " then
      'extend its name upto the end of string now:
      WVariableLimitorPosition = L + 1
      FinalParsingPosition = L + 1
   Else
      WVariableLimitorPosition = I1
      FinalParsingPosition = I1 + 1 'drop " "
   End If
                
   'check for case "$ ":
   If I + 1 = WVariableLimitorPosition Then GoTo EmptyName
            
   wi = InStr(I, s, VariableLimitor2) 'cr
   If wi <> 0 And wi < WVariableLimitorPosition Then
      WVariableLimitorPosition = wi
      FinalParsingPosition = WVariableLimitorPosition
   End If
   wi = InStr(I, s, VariableLimitor3) 'lf
   If wi <> 0 And wi < WVariableLimitorPosition Then
      WVariableLimitorPosition = wi
      FinalParsingPosition = WVariableLimitorPosition
   End If
   wi = InStr(I, s, VariableLimitor4) 'tab
   If wi <> 0 And wi < WVariableLimitorPosition Then
      WVariableLimitorPosition = wi
      FinalParsingPosition = WVariableLimitorPosition
   End If
   wi = InStr(I, s, VariableLImitor5) 'tab
   If wi <> 0 And wi < WVariableLimitorPosition Then
      WVariableLimitorPosition = wi
      FinalParsingPosition = WVariableLimitorPosition
   End If
                
EmptyName:
   
   ResultString = ResultString & e_char & variable_escaper & _
                  Mid(s, I + 1, _
                  WVariableLimitorPosition - I - 1) & _
                  alph__VariableEscapeLimitor 'WVarNameLimitor
   
   I = FinalParsingPosition
   flag_substitute_variable_later = True
   GoTo ContinueMainLoop
   '------------------------------------
   'ef NAME OF VARIABLE
   '====================================
            
End If
         
'=================================================
'"normal" case: w_current_char simply is "a char":
ResultString = ResultString & w_current_char
'skip this single char:
I = I + 1
GoTo ContinueMainLoop
'=================================================
      

        
        
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
' THIS IS AN ESCAPE SEQUENCE:
EscapeSequence:
   
I1 = I + 1
wi = Asc(Mid(s, I1, 1))
      
      
'==========================================
' Process numeric escape like \125
'------------------------------------------
If wi < 58 And wi > 47 Then
   'this is char in ascii:
   'take three characters on positions
   'i+1, i+2, i+3
   ResultString = ResultString & _
        Chr(CInt(Mid(s, I1, 3))): I = I + 4
   GoTo ContinueMainLoop
End If
'==========================================
      
      
WControlChar$ = Mid(s, I1, 1)
Select Case WControlChar
                
   Case e_char: 'found \\; flag it:
        ' the only place where this flag is set:
        flag_esc_esc_found = True
        ResultString = ResultString & e_char & e_char: I = I + 2
                 
   
   '===============================================================
   '  remove used escaper
   '---------------------------------------------------------------
   Case variable_escaper:
        ResultString = ResultString & variable_escaper: I = I + 2
        'microbug: 'flag_substitute_variable_later = True
   '===============================================================
     
                
   '===============================================================
   '  early binding
   '---------------------------------------------------------------
   'web aware:
   Case "_": ResultString = ResultString & "&nbsp;": I = I + 2
   Case ">": ResultString = ResultString & "&gt;": I = I + 2
   Case "<": ResultString = ResultString & "&lt;": I = I + 2
   Case """": ResultString = ResultString & "&qout;": I = I + 2
   Case "&": ResultString = ResultString & "&amp;": I = I + 2
   Case "|": ResultString = ResultString & "<br />": I = I + 2
   Case "/": ResultString = ResultString & _
                            "<br />" & vbCrLf: I = I + 2
     
   'pure text:
   Case "l": ResultString = ResultString & vbCrLf: I = I + 2
   Case "r": ResultString = ResultString & vbCr: I = I + 2
   Case "n": ResultString = ResultString & vbLf: I = I + 2
   Case "t": ResultString = ResultString & vbTab: I = I + 2
   Case "z": ResultString = ResultString & Chr(0): I = I + 2
   Case "N": ResultString = ResultString & vbLf & vbLf: I = I + 2
   
   '---------------------------------------------------------------
   '  ef early binding
   '===============================================================
                
       
   '===============================================================
   '  late binding
   '---------------------------------------------------------------
   'comma is needed for I,P ...
   'hence "c" can be used ...
   Case "L", "U", "B", "E", "M", "S", "V", _
        "P", "I", _
        "R", _
        "w", "W", "f", "F", "g", "G", "c", "s", "p", _
        "H", "T", "D", "d", "x", "X", _
        "h", "Z", "e", _
        "?", "#"
        
          
        ResultString = ResultString & e_char & WControlChar
        I = I + 2
        flag_substitute_variable_later = True
   '---------------------------------------------------------------
   '  ef late binding
   '===============================================================
           
   Case Else:
        'for unknown control character,
        'drop escaper and preserve control:
        ResultString = ResultString & WControlChar: I = I + 2
          
End Select

'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
ContinueMainLoop:     DoEvents
    
'=====================================================
Loop    'ef MAIN LOOP
'=====================================================
    
EndOfFunction:

'==========================================================
'  MAKE RESULT A PLAIN TEXT
'  "IF NOTHING MORE TO SUBSTITUTE"
'----------------------------------------------------------
If Not flag_substitute_variable_later Then
    If flag_esc_esc_found Then
       
       'kk.later: check: this can be dangerous replacement:
       '                 hope vb does it right:
       ResultString = Replace(ResultString, _
                      e_char & e_char, e_char)
    End If
End If
'==========================================================

SoftEscape = ResultString
 
 
'-----------------------------------------------------------------
'for future modifications:
'
'clean up the string from escapes if nothing more to substitute:

'THIS CAN BE MODIFIED TO MAKE TWO DISTINGUSHED FLAGS:
'flag_substitute_escaped_later AND flag_substitute_variable_later
'
'Dim flag_substitute_escaped_later As Boolean
'flag_substitute_escaped_later = False
'.....
'If (Not flag_substitute_escaped_later) And _
'   (Not flag_substitute_variable_later) Then
'   If flag_esc_esc_found Then ResultString = _
'   Replace(ResultString, e_char & e_char, e_char)
'End If
'SoftEscape = ResultString
'
'-----------------------------------------------------------------
 
End Function

'DESCRIPTION:    simply extracts string R=" ....""...." from
'                " ....""...."......
'                "SURROUNDING" DOUBLE QUOTATION MARKS preservation depends on StripQMarks;
'                if RecognizeDoubleQuouters, then "" combination included in the string;
'
'                NO ESCAPES ARE HANDLED (EXECEPT ")
'
'
'INPUT:  SourceS - must have "  at StartPos which will be skipped and which marks
'                 the beginning of the searched string;
'        StartPos
'        RecognizeDoubleQuoters
'        StripQMarks
'OUTPUT: returns R
'        EndPos - character next after last "
'
'
Public Function CutQuotedString$(SourceS$, StartPos&, EndPos&, RecognizeDoubleQuouters As Boolean, _
                StripQMarks As Boolean, ConvertToPHP$, tz_tring_case_P$)
Dim CurrentPos&, wi&, result$, ResultL&


ResultL = Len(SourceS)
'first character (usually ") is skipped:
CurrentPos = StartPos + 1
If CurrentPos > Len(SourceS) Then
   result = ""
   EndPos = ResultL + 1
   GoTo EndOfFunction
End If

Again: DoEvents
'locate position of the next ":
wi = InStr(CurrentPos, SourceS, """")
If wi = 0 Then
   'return all plus "complete" string with ":
   result = Mid(SourceS, CurrentPos)
   EndPos = ResultL + 1
   GoTo EndOfFunction
End If

If Mid(SourceS, wi + 1, 1) = """" And RecognizeDoubleQuouters Then
   CurrentPos = wi + 2
   GoTo Again
Else
   result = Mid(SourceS, StartPos + 1, wi - StartPos - 1)
   EndPos = wi + 1  'next pos
End If

EndOfFunction:

Select Case tz_tring_case_P
   Case "U": result = UCase(result)
   Case "L": result = LCase(result)
End Select

'do2 slow:
If "P" = ConvertToPHP Then
   result = Replace(Replace(Replace(result, "\", "\\"), """""", "\"""), "$", "\$")
End If
'If tz_conv_str = "P" Then result = Replace(Replace(Replace(result, "\", "\\"), """""", "\"""), "$", "\$")

If StripQMarks Then
   CutQuotedString = result
Else
   CutQuotedString = """" & result & """"
End If

End Function






